module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/ 		var executeModules = data[2];
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 		// add entry modules from loaded chunk to deferred list
/******/ 		deferredModules.push.apply(deferredModules, executeModules || []);
/******/
/******/ 		// run deferred modules when all chunks ready
/******/ 		return checkDeferredModules();
/******/ 	};
/******/ 	function checkDeferredModules() {
/******/ 		var result;
/******/ 		for(var i = 0; i < deferredModules.length; i++) {
/******/ 			var deferredModule = deferredModules[i];
/******/ 			var fulfilled = true;
/******/ 			for(var j = 1; j < deferredModule.length; j++) {
/******/ 				var depId = deferredModule[j];
/******/ 				if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 			}
/******/ 			if(fulfilled) {
/******/ 				deferredModules.splice(i--, 1);
/******/ 				result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 			}
/******/ 		}
/******/
/******/ 		return result;
/******/ 	}
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		67: 0
/******/ 	};
/******/
/******/ 	var deferredModules = [];
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	var jsonpArray = (typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// add entry module to deferred list
/******/ 	deferredModules.push(["dd63",17,45,24,11,44,47,18,15,53,6,12,27,55,21,29,42,41,4,71,65,7,73,51,56,1,70,30,52,63,49,35,22,54,10,57,40,9,48,13,46,62,26,34,66,69,28,25,8,64,72,20,38,23,61,31,2,43,36,0,60,59,58,32,14,33,50,39,5,16,68,37,3,19]);
/******/ 	// run deferred modules when ready
/******/ 	return checkDeferredModules();
/******/ })
/************************************************************************/
/******/ ({

/***/ "0083":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _SideMenu_vue_vue_type_template_id_114459a8_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("5524");
/* harmony import */ var _SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("64ef");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _SideMenu_vue_vue_type_template_id_114459a8_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "00a8":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("ef14");

__webpack_require__("52f9");

__webpack_require__("88a1");

__webpack_require__("2aa5");

__webpack_require__("0d9f");

__webpack_require__("32f5");

__webpack_require__("62c8");

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_hasura_backend_plus_1 = __webpack_require__("f154");

var usetoast_1 = __webpack_require__("de6a");

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

var composables_1 = __webpack_require__("2746");

exports["default"] = vue_1.defineComponent({
  name: 'SideMenu',
  props: {
    modelValue: Boolean
  },
  emits: ['update:modelValue'],
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    vue_1.onMounted(function () {
      if (mobileMenuActive.value) addClass(document.body, 'body-overflow-hidden');else removeClass(document.body, 'body-overflow-hidden');
    });
    vue_1.watch(function () {
      return props.modelValue;
    }, function (val) {
      console.log('CHange model value', val);
    }, {
      immediate: true
    });
    var toast = usetoast_1.useToast();
    var layoutColorMode = vue_1.ref('dark');
    var mobileMenuActive = vue_1.ref(false);
    var route = vue_router_1.useRoute();
    var fullMenu = composables_1.useFullMenu();
    var menu = composables_1.useFilteredMenu(fullMenu, function (item, r) {
      if (r) {
        if (status.value) {
          return r.meta.auth !== false;
        } else {
          return r.meta.auth !== true;
        }
      } else return true;
    });
    var status = vue_hasura_backend_plus_1.useStatus();
    vue_1.watch(function () {
      return route.path;
    }, function () {
      menuActive.value = false;
      toast.removeAllGroups();
    });
    var sidebarClass = vue_1.computed(function () {
      return [layoutColorMode.value === 'dark' ? 'layout-sidebar-dark' : 'layout-sidebar-light'];
    });
    var logo = vue_1.computed(function () {
      return 'assets/layout/images/logo-white.svg';
    });

    var addClass = function addClass(element, className) {
      if (element.classList) element.classList.add(className);else element.className += ' ' + className;
    };

    var removeClass = function removeClass(element, className) {
      if (element.classList) element.classList.remove(className);else element.className = element.className.replace(new RegExp('(^|\\b)' + className.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
    };

    var isDesktop = vue_1.computed(function () {
      return window.innerWidth > 1024;
    });

    var onItemClick = function onItemClick(event) {
      console.log('onItemClick');

      if (event.item && !event.item.items) {
        menuActive.value = false;
      }
    };

    var menuActive = vue_1.computed({
      get: function get() {
        if (isDesktop.value) {
          return props.modelValue;
        } else {
          return true;
        }
      },
      set: function set(value) {
        console.log('set menuActive');
        emit('update:modelValue', value);
      }
    });
    var isPanelOpen = vue_1.ref(true);
    return {
      isPanelOpen: isPanelOpen,
      menuActive: menuActive,
      sidebarClass: sidebarClass,
      logo: logo,
      menu: menu,
      status: status,
      onItemClick: onItemClick
    };
  }
});

/***/ }),

/***/ "02b7":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _CollectionPage_vue_vue_type_template_id_80abdbf4_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("d34f");
/* harmony import */ var _CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("67e4");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _CollectionPage_vue_vue_type_template_id_80abdbf4_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "0727":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Profile_vue_vue_type_template_id_7346ce04_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("7161");
/* harmony import */ var _Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("9790");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var _Profile_vue_vue_type_style_index_0_id_7346ce04_lang_css__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("be53");





_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Profile_vue_vue_type_template_id_7346ce04_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "0d7c":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("47f6");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "1c2c":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_1 = __webpack_require__("8bbf");

exports["default"] = vue_1.defineComponent({
  name: 'Submenu',
  props: {
    items: {
      type: Array,
      "default": []
    },
    root: {
      type: Boolean,
      "default": false
    }
  },
  emits: ['item-click'],
  setup: function setup(_, _ref) {
    var emit = _ref.emit;
    var activeIndex = vue_1.ref();

    var onItemClick = function onItemClick(event, item, index) {
      if (item.disabled) {
        event.preventDefault();
        return;
      }

      if (!item.to && !item.url) {
        event.preventDefault();
      }

      if (item.command) {
        item.command({
          originalEvent: event,
          item: item
        });
      }

      activeIndex.value = index === activeIndex.value ? undefined : index;
      emit('item-click', {
        originalEvent: event,
        item: item
      });
    };

    var visible = function visible(item) {
      return typeof item.visible === 'function' ? item.visible() : item.visible !== false;
    };

    return {
      activeIndex: activeIndex,
      onItemClick: onItemClick,
      visible: visible
    };
  }
});

/***/ }),

/***/ "1c60":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/layout/Menu.vue?vue&type=template&id=15fee5aa&lang=pug

var _hoisted_1 = {
  "class": "layout-menu-container"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_h_submenu = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-submenu");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_h_submenu, {
    "class": "layout-menu",
    items: _ctx.model,
    root: true,
    onItemClick: _ctx.onItemClick
  }, null, 8, ["items", "onItemClick"])]);
}
// CONCATENATED MODULE: ./src/layout/Menu.vue?vue&type=template&id=15fee5aa&lang=pug


/***/ }),

/***/ "1f8a":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("2aa5");

__webpack_require__("32f5");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

var vuex_1 = __webpack_require__("78db");

var composables_1 = __webpack_require__("2746");

exports["default"] = vue_1.defineComponent({
  name: 'ProfilePage',
  props: {
    editing: {
      type: Boolean,
      "default": false
    }
  },
  setup: function setup() {
    var _this = this;

    var profile = composables_1.useProfile();
    var displayName = composables_1.useDisplayName(profile);
    var router = vue_router_1.useRouter();
    var properties = vue_1.computed(function () {
      var _a;

      return (_a = profile.value) === null || _a === void 0 ? void 0 : _a.collection.properties;
    });
    var store = vuex_1.useStore();
    var form = vue_1.computed(function () {
      return store.getters['rxdb/form'];
    });

    var read = function read() {
      return profile.value && router.replace({
        name: 'profile'
      });
    };

    var edit = function edit() {
      return profile.value && router.replace({
        name: 'profile',
        params: {
          action: 'edit'
        }
      });
    };

    var save = function save() {
      return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return store.dispatch('rxdb/save');

              case 2:
                read();

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    };

    var reset = function reset() {
      store.commit('rxdb/reset');
    };

    var cancel = function cancel() {
      reset();
      read();
    };

    return {
      profile: profile,
      form: form,
      properties: properties,
      save: save,
      reset: reset,
      cancel: cancel,
      edit: edit,
      displayName: displayName
    };
  }
});

/***/ }),

/***/ "2037":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _DocumentPage_vue_vue_type_template_id_083d4208_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("2862");
/* harmony import */ var _DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("502a");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _DocumentPage_vue_vue_type_template_id_083d4208_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "2862":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/pages/contents/DocumentPage.vue?vue&type=template&id=083d4208&lang=pug


var _hoisted_1 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, "Last updated by", -1);

var _hoisted_2 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, "created by", -1);

var _hoisted_3 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, "created at", -1);

var _hoisted_4 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, "revisions", -1);

var _hoisted_5 = {
  "class": "card"
};
var _hoisted_6 = {
  key: 1
};

var _hoisted_7 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("New ");

var _hoisted_8 = {
  "class": "p-text-lowercase"
};
var _hoisted_9 = {
  key: 1,
  "class": "card"
};
var _hoisted_10 = {
  key: 2,
  "class": "card"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _ctx$collection;

  var _component_p_sidebar = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-sidebar");

  var _component_h_document_label = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-document-label");

  var _component_p_button = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-button");

  var _component_p_toolbar = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-toolbar");

  var _component_h_document = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-document");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Fragment"], null, [_ctx.collection && _ctx.document ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", {
    key: _ctx.document.primary
  }, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_sidebar, {
    visible: _ctx.visibleInfo,
    "onUpdate:visible": _cache[1] || (_cache[1] = function ($event) {
      return _ctx.visibleInfo = $event;
    }),
    position: "right"
  }, {
    "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, "Last updated at: " + Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.document.updated_at), 1), _hoisted_1, _hoisted_2, _hoisted_3, _hoisted_4];
    }),
    _: 1
  }, 8, ["visible"]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", _hoisted_5, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("h3", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
    "class": ["p-mr-2", _ctx.collection.icon()]
  }, null, 2), _ctx.id ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_h_document_label, {
    key: 0,
    document: _ctx.document
  }, null, 8, ["document"])) : (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("span", _hoisted_6, [_hoisted_7, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", _hoisted_8, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.collection.documentTitle()), 1)]))]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_toolbar, {
    "class": "p-mb-4"
  }, {
    left: Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [!_ctx.editing && _ctx.collection.canUpdate() ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 0,
        "class": "p-mr-2",
        icon: "pi pi-pencil",
        label: "Edit",
        onClick: _ctx.edit
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), !_ctx.editing && _ctx.document.canDelete() ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 1,
        "class": "p-mr-2",
        icon: "pi pi-times",
        label: "Delete",
        onClick: _ctx.remove
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing && _ctx.collection.canUpdate() ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 2,
        "class": "p-mr-2",
        icon: "pi pi-save",
        label: "Save",
        onClick: _ctx.save
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing && _ctx.collection.canUpdate() ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 3,
        "class": "p-mr-2",
        icon: "pi pi-undo",
        label: "Reset",
        onClick: _ctx.reset
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing && _ctx.collection.canUpdate() ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 4,
        "class": "p-mr-2",
        icon: "pi pi-times",
        label: "Cancel",
        onClick: _ctx.cancel
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)];
    }),
    right: Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_button, {
        "class": "p-button-rounded p-button-text",
        icon: "pi pi-info-circle",
        onClick: _ctx.toggleInfo
      }, null, 8, ["onClick"])];
    }),
    _: 1
  }), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_h_document, {
    document: _ctx.document,
    editing: _ctx.editing,
    layout: "details"
  }, null, 8, ["document", "editing"])])])) : (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_9, "loading document...")), (_ctx$collection = _ctx.collection) !== null && _ctx$collection !== void 0 && _ctx$collection.canUpdate() && _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_10, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.form), 1)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)], 64);
}
// CONCATENATED MODULE: ./src/pages/contents/DocumentPage.vue?vue&type=template&id=083d4208&lang=pug


/***/ }),

/***/ "2d12":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("78ba");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "37c3":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("df26");

var _slicedToArray = __webpack_require__("75d5");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_hasura_backend_plus_1 = __webpack_require__("f154");

var core_1 = __webpack_require__("b6de");

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

var composables_1 = __webpack_require__("2746");

exports["default"] = vue_1.defineComponent({
  name: 'Profile',
  setup: function setup() {
    var _this = this;

    var db = composables_1.useDB();

    var _core_1$useToggle = core_1.useToggle(false),
        _core_1$useToggle2 = _slicedToArray(_core_1$useToggle, 2),
        expanded = _core_1$useToggle2[0],
        toggle = _core_1$useToggle2[1];

    var router = vue_router_1.useRouter();
    var hbpLogout = vue_hasura_backend_plus_1.useLogout();
    var profile = composables_1.useProfile();

    var logout = function logout() {
      return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _a;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return hbpLogout();

              case 2:
                _context.next = 4;
                return (_a = db.value) === null || _a === void 0 ? void 0 : _a.remove();

              case 4:
                router.push({
                  name: 'root'
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    };

    var displayName = composables_1.useDisplayName(profile);
    var initial = composables_1.useInitial(displayName);
    return {
      expanded: expanded,
      toggle: toggle,
      logout: logout,
      profile: profile,
      displayName: displayName,
      initial: initial
    };
  }
});

/***/ }),

/***/ "3a0b":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("9531");

__webpack_require__("ef14");

__webpack_require__("e416");

__webpack_require__("868d");

__webpack_require__("8f84");

__webpack_require__("52f9");

__webpack_require__("6559");

__webpack_require__("f8a5");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("2aa5");

__webpack_require__("f3b8");

__webpack_require__("918c");

var _slicedToArray = __webpack_require__("75d5");

__webpack_require__("df26");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addModule = void 0;

var rxdb_hasura_1 = __webpack_require__("9c85");

var immutable = __importStar(__webpack_require__("162b"));

var state = function state() {
  return {
    forms: {}
  };
};

var addModule = function addModule(db, store) {
  store.registerModule('rxdb', {
    namespaced: true,
    state: state,
    getters: {
      form: function form(state) {
        return state.forms;
      },
      getField: function getField(state) {
        return function (document, field) {
          return document && immutable.get(state.forms, "".concat(document.collection.name, ".").concat(document.primary, ".").concat(field));
        };
      }
    },
    actions: {
      save: function save(_ref) {
        var state = _ref.state,
            commit = _ref.commit;
        return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var _i, _Object$entries, _Object$entries$_i, collectionName, documents, collection, _loop, _i2, _Object$entries2;

          return regeneratorRuntime.wrap(function _callee$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (db.value) {
                    _context2.next = 2;
                    break;
                  }

                  return _context2.abrupt("return");

                case 2:
                  _i = 0, _Object$entries = Object.entries(state.forms);

                case 3:
                  if (!(_i < _Object$entries.length)) {
                    _context2.next = 16;
                    break;
                  }

                  _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2), collectionName = _Object$entries$_i[0], documents = _Object$entries$_i[1];
                  collection = db.value[collectionName];
                  _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
                    var _Object$entries2$_i, documentId, formValues, document, changed, values;

                    return regeneratorRuntime.wrap(function _loop$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _Object$entries2$_i = _slicedToArray(_Object$entries2[_i2], 2), documentId = _Object$entries2$_i[0], formValues = _Object$entries2$_i[1];
                            _context.next = 3;
                            return collection.findOne(documentId).exec();

                          case 3:
                            document = _context.sent;

                            if (!document) {
                              _context.next = 20;
                              break;
                            }

                            changed = Object.entries(formValues).some(function (_ref2) {
                              var _ref3 = _slicedToArray(_ref2, 2),
                                  key = _ref3[0],
                                  value = _ref3[1];

                              return document.get(key) !== value;
                            });

                            if (!changed) {
                              _context.next = 17;
                              break;
                            }

                            _context.prev = 7;
                            _context.next = 10;
                            return document.atomicPatch(formValues);

                          case 10:
                            _context.next = 15;
                            break;

                          case 12:
                            _context.prev = 12;
                            _context.t0 = _context["catch"](7);
                            console.error(_context.t0);

                          case 15:
                            _context.next = 18;
                            break;

                          case 17:
                            console.info('No document changed');

                          case 18:
                            _context.next = 24;
                            break;

                          case 20:
                            values = collection.newDocument(formValues);
                            values.set(collection.schema.primaryPath, documentId);
                            _context.next = 24;
                            return values.save();

                          case 24:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _loop, null, [[7, 12]]);
                  });
                  _i2 = 0, _Object$entries2 = Object.entries(documents);

                case 8:
                  if (!(_i2 < _Object$entries2.length)) {
                    _context2.next = 13;
                    break;
                  }

                  return _context2.delegateYield(_loop(), "t0", 10);

                case 10:
                  _i2++;
                  _context2.next = 8;
                  break;

                case 13:
                  _i++;
                  _context2.next = 3;
                  break;

                case 16:
                  commit('reset');

                case 17:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee);
        }));
      }
    },
    mutations: {
      setField: function setField(state, _ref4) {
        var document = _ref4.document,
            field = _ref4.field,
            value = _ref4.value;
        var collection = document.collection;
        state.forms = immutable.set(state.forms, "".concat(collection.name, ".").concat(document.primary, ".").concat(field), rxdb_hasura_1.castValue(document, field, value));
      },
      resetField: function resetField(state, _ref5) {
        var document = _ref5.document,
            field = _ref5.field;
        var collection = document.collection;
        state.forms = deletePath(state.forms, [collection.name, document.primary, field]);
      },
      reset: function reset(state) {
        state.forms = {};
      }
    },
    modules: {}
  });
};

exports.addModule = addModule;

var deletePath = function deletePath(object, path) {
  var result = immutable.del(object, path.join('.'));
  path.pop();
  if (path.length && !Object.keys(immutable.get(result, path.join('.'))).length) return deletePath(object, path);else return result;
};

/***/ }),

/***/ "3c68":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("868d");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("2aa5");

__webpack_require__("32f5");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

var vuex_1 = __webpack_require__("78db");

var composables_1 = __webpack_require__("2746");

exports["default"] = vue_1.defineComponent({
  name: 'CollectionPage',
  props: {
    name: {
      type: String,
      required: true
    },
    editing: {
      type: Boolean,
      "default": false
    }
  },
  setup: function setup(props) {
    var _this = this;

    vue_router_1.onBeforeRouteUpdate(function () {});
    vue_router_1.onBeforeRouteLeave(function () {});
    var router = vue_router_1.useRouter();
    var collectionName = vue_1.toRef(props, 'name');
    var collection = composables_1.useCollection(collectionName);
    var canEdit = vue_1.computed(function () {
      var _a, _b;

      return ((_a = collection.value) === null || _a === void 0 ? void 0 : _a.defaultView()) !== 'card' && !!((_b = collection.value) === null || _b === void 0 ? void 0 : _b.canUpdate());
    });
    var store = vuex_1.useStore();
    var form = vue_1.computed(function () {
      return store.getters['rxdb/form'];
    });

    var read = function read() {
      return router.replace({
        name: 'collection',
        params: {
          name: props.name
        }
      });
    };

    var edit = function edit() {
      return router.replace({
        name: 'collection',
        params: {
          name: props.name,
          action: 'edit'
        }
      });
    };

    var create = function create() {
      return router.push({
        name: 'newDocument',
        params: {
          collection: props.name
        }
      });
    };

    var save = function save() {
      return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return store.dispatch('rxdb/save');

              case 2:
                read();

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    };

    var reset = function reset() {
      store.commit('rxdb/reset');
    };

    var cancel = function cancel() {
      reset();
      read();
    };

    return {
      form: form,
      collection: collection,
      save: save,
      reset: reset,
      cancel: cancel,
      canEdit: canEdit,
      edit: edit,
      create: create
    };
  }
});

/***/ }),

/***/ "424c":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/pages/profile/Profile.vue?vue&type=template&id=ad76df0c&lang=pug

var _hoisted_1 = {
  key: 0,
  "class": "card"
};

var _hoisted_2 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
  "class": "p-mr-2"
}, null, -1);

var _hoisted_3 = {
  key: 1,
  "class": "card"
};
var _hoisted_4 = {
  key: 2,
  "class": "card"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_p_button = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-button");

  var _component_p_toolbar = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-toolbar");

  var _component_h_document = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-document");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Fragment"], null, [_ctx.profile ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("h3", null, [_hoisted_2, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.displayName), 1)]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_toolbar, {
    "class": "p-mb-4"
  }, {
    left: Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [!_ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 0,
        "class": "p-mr-2",
        icon: "pi pi-pencil",
        label: "Edit",
        onClick: _ctx.edit
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 1,
        "class": "p-mr-2",
        icon: "pi pi-save",
        label: "Save",
        onClick: _ctx.save
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 2,
        "class": "p-mr-2",
        icon: "pi pi-undo",
        label: "Reset",
        onClick: _ctx.reset
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 3,
        "class": "p-mr-2",
        icon: "pi pi-times",
        label: "Cancel",
        onClick: _ctx.cancel
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)];
    }),
    _: 1
  }), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_h_document, {
    document: _ctx.profile,
    editing: _ctx.editing,
    layout: "details"
  }, null, 8, ["document", "editing"])])) : (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_3, "loading profile... -" + Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.profile) + "-", 1)), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_4, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.form), 1)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)], 64);
}
// CONCATENATED MODULE: ./src/pages/profile/Profile.vue?vue&type=template&id=ad76df0c&lang=pug


/***/ }),

/***/ "4283":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/layout/Submenu.vue?vue&type=template&id=358e41c2&lang=pug

var _hoisted_1 = {
  key: 0
};
var _hoisted_2 = {
  key: 0,
  "class": "arrow"
};
var _hoisted_3 = {
  key: 0,
  "class": "pi pi-fw pi-angle-down menuitem-toggle-icon"
};
var _hoisted_4 = {
  key: 1,
  "class": "menuitem-badge"
};
var _hoisted_5 = {
  key: 0,
  "class": "pi pi-fw pi-angle-down menuitem-toggle-icon"
};
var _hoisted_6 = {
  key: 1,
  "class": "menuitem-badge"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_router_link = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("router-link");

  var _component_h_submenu = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-submenu");

  var _directive_ripple = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveDirective"])("ripple");

  return _ctx.items ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("ul", _hoisted_1, [(Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(true), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Fragment"], null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["renderList"])(_ctx.items, function (item, i) {
    return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Fragment"], null, [_ctx.visible(item) && !item.separator ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("li", {
      key: i,
      "class": [{
        'active-menuitem': _ctx.activeIndex === i && !item.to && !item.disabled
      }],
      role: "none"
    }, [item.items && _ctx.root === true ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_2)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), item.to ? Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withDirectives"])((Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_router_link, {
      key: 1,
      to: item.to,
      "class": [item["class"], 'p-ripple', {
        'active-route': _ctx.activeIndex === i,
        'p-disabled': item.disabled
      }],
      style: item.style,
      onClick: function onClick($event) {
        return _ctx.onItemClick($event, item, i);
      },
      target: item.target,
      exact: "",
      role: "menuitem"
    }, {
      "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
        return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
          "class": item.icon
        }, null, 2), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(item.label), 1), item.items ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("i", _hoisted_3)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), item.badge ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("span", _hoisted_4, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(item.badge), 1)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)];
      }),
      _: 2
    }, 1032, ["to", "class", "style", "onClick", "target"])), [[_directive_ripple]]) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), !item.to ? Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withDirectives"])((Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("a", {
      key: 2,
      href: item.url || '#',
      style: item.style,
      "class": [item["class"], 'p-ripple', {
        'p-disabled': item.disabled
      }],
      onClick: function onClick($event) {
        return _ctx.onItemClick($event, item, i);
      },
      target: item.target,
      role: "menuitem"
    }, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
      "class": item.icon
    }, null, 2), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(item.label), 1), item.items ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("i", _hoisted_5)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), item.badge ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("span", _hoisted_6, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(item.badge), 1)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)], 14, ["href", "onClick", "target"])), [[_directive_ripple]]) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Transition"], {
      name: "layout-submenu-wrapper"
    }, {
      "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
        return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withDirectives"])(Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_h_submenu, {
          items: _ctx.visible(item) && item.items,
          onItemClick: _cache[1] || (_cache[1] = function ($event) {
            return _ctx.$emit('item-click', $event);
          })
        }, null, 8, ["items"]), [[external_commonjs_vue_commonjs2_vue_root_Vue_["vShow"], _ctx.activeIndex === i]])];
      }),
      _: 2
    }, 1024)], 2)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.visible(item) && item.separator ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("li", {
      "class": "p-menu-separator",
      style: item.style,
      key: 'separator' + i,
      role: "separator"
    }, null, 4)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)], 64);
  }), 256))])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true);
}
// CONCATENATED MODULE: ./src/layout/Submenu.vue?vue&type=template&id=358e41c2&lang=pug


/***/ }),

/***/ "479d":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d6de");

__webpack_require__("8d0f");

__webpack_require__("8f0b");

__webpack_require__("9531");

__webpack_require__("868d");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("fa8c");

__webpack_require__("918c");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createVueRxDBHasuraPlugin = exports.DefaultRxDBKey = void 0;

var rxdb_hasura_1 = __webpack_require__("9c85");

var vue_1 = __webpack_require__("8bbf");

var primevue_1 = __webpack_require__("7dda");

var store_1 = __webpack_require__("3a0b");

exports.DefaultRxDBKey = Symbol();

var createVueRxDBHasuraPlugin = function createVueRxDBHasuraPlugin(_ref) {
  var name = _ref.name,
      endpoint = _ref.endpoint,
      hbp = _ref.hbp,
      store = _ref.store,
      router = _ref.router;
  var db = vue_1.ref();

  var install = function install(app, injectKey) {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var components;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              rxdb_hasura_1.createRxHasura(name, endpoint).then(function (value) {
                db.value = value;
                value.setAuthStatus(!!hbp.auth.isAuthenticated(), hbp.auth.getJWTToken());
                hbp.auth.onAuthStateChanged(function (status) {
                  return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            value.setAuthStatus(status, hbp.auth.getJWTToken());

                          case 1:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));
                });
                hbp.auth.onTokenChanged(function (token) {
                  console.log('onTokenChanged', token);
                  value.setJwt(hbp.auth.getJWTToken());
                });
              });
              components = __webpack_require__("8bb8");
              components.keys().forEach(function (filename) {
                var Comp = components(filename)["default"];
                app.component("H".concat(Comp.name), Comp);
              });
              app.provide(injectKey || exports.DefaultRxDBKey, db);
              store_1.addModule(db, store);
              primevue_1.loadPrimeVue(app);

              if (router) {
                router.beforeEach(function (to, from, next) {
                  window.scrollTo(0, 0);
                  if (to.meta.auth && !hbp.authenticated.value) next({
                    name: 'login'
                  });else if (hbp.authenticated.value && to.path === '/') next({
                    name: 'home'
                  });else if (!to.matched.length) next({
                    name: 'root'
                  });else next();
                });
              }

            case 7:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
  };

  return {
    db: db,
    install: install
  };
};

exports.createVueRxDBHasuraPlugin = createVueRxDBHasuraPlugin;

/***/ }),

/***/ "47f6":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_1 = __webpack_require__("8bbf");

var Submenu_vue_1 = __importDefault(__webpack_require__("c678"));

exports["default"] = vue_1.defineComponent({
  name: 'Menu',
  components: {
    Submenu: Submenu_vue_1["default"]
  },
  props: {
    model: {
      type: Array,
      "default": []
    }
  },
  emits: ['item-click'],
  setup: function setup(_, _ref) {
    var emit = _ref.emit;

    var onItemClick = function onItemClick(event) {
      emit('item-click', event);
    };

    return {
      onItemClick: onItemClick
    };
  }
});

/***/ }),

/***/ "4e27":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/layout/Footer.vue?vue&type=template&id=6ad517cc&lang=pug

var _hoisted_1 = {
  "class": "layout-footer"
};

var _hoisted_2 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "footer-text",
  style: {
    "margin-right": "5px"
  }
}, "Platyplus", -1);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [_hoisted_2]);
}
// CONCATENATED MODULE: ./src/layout/Footer.vue?vue&type=template&id=6ad517cc&lang=pug


/***/ }),

/***/ "502a":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("bbb4");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_DocumentPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "5524":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/layout/SideMenu.vue?vue&type=template&id=114459a8&lang=pug

var _hoisted_1 = {
  "class": "layout-logo"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_router_link = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("router-link");

  var _component_h_profile = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-profile");

  var _component_h_menu = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-menu");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Transition"], {
    name: "layout-sidebar"
  }, {
    "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withDirectives"])(Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", {
        "class": ["layout-sidebar", _ctx.sidebarClass],
        onClick: _cache[1] || (_cache[1] = function () {
          return _ctx.onSidebarClick && _ctx.onSidebarClick.apply(_ctx, arguments);
        })
      }, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.modelValue), 1), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", _hoisted_1, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_router_link, {
        to: {
          name: 'home'
        }
      }, {
        "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
          return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("img", {
            alt: "Logo",
            src: _ctx.logo
          }, null, 8, ["src"])];
        }),
        _: 1
      })]), _ctx.status ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_h_profile, {
        key: 0
      })) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_h_menu, {
        model: _ctx.menu,
        onItemClick: _ctx.onItemClick
      }, null, 8, ["model", "onItemClick"])], 2), [[external_commonjs_vue_commonjs2_vue_root_Vue_["vShow"], _ctx.menuActive]])];
    }),
    _: 1
  });
}
// CONCATENATED MODULE: ./src/layout/SideMenu.vue?vue&type=template&id=114459a8&lang=pug


/***/ }),

/***/ "5c58":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("e792");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "5d48":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_hasura_backend_plus_1 = __webpack_require__("f154");

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

exports["default"] = vue_1.defineComponent({
  name: 'Register',
  setup: function setup() {
    var _this = this;

    var router = vue_router_1.useRouter();
    var email = vue_1.ref('');
    var password = vue_1.ref('');

    var _vue_hasura_backend_p = vue_hasura_backend_plus_1.useRegister(email, password),
        register = _vue_hasura_backend_p.register,
        error = _vue_hasura_backend_p.error;

    var registerUser = function registerUser() {
      return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return register();

              case 2:
                if (!error.value) {
                  router.push({
                    name: 'root'
                  });
                }

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    };

    return {
      email: email,
      password: password,
      registerUser: registerUser,
      status: status,
      error: error
    };
  }
});

/***/ }),

/***/ "64ef":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("00a8");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_SideMenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "662a":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_8_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_8_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_8_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_8_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_style_index_0_id_31f1c1f6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("e874");
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_8_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_8_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_8_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_8_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_style_index_0_id_31f1c1f6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_mini_css_extract_plugin_dist_loader_js_ref_8_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_8_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_8_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_8_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_style_index_0_id_31f1c1f6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_0__);
/* unused harmony reexport * */


/***/ }),

/***/ "67e4":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("3c68");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_CollectionPage_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "70cf":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_8_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_8_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_8_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_8_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_style_index_0_id_ad4808a6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("a8d5");
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_8_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_8_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_8_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_8_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_style_index_0_id_ad4808a6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_mini_css_extract_plugin_dist_loader_js_ref_8_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_8_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_8_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_8_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Login_vue_vue_type_style_index_0_id_ad4808a6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_0__);
/* unused harmony reexport * */


/***/ }),

/***/ "7161":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/layout/Profile.vue?vue&type=template&id=7346ce04&lang=pug

var _hoisted_1 = {
  key: 0,
  "class": "layout-profile"
};
var _hoisted_2 = {
  "class": "username"
};

var _hoisted_3 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
  "class": "pi pi-fw pi-cog"
}, null, -1);

var _hoisted_4 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
  "class": "p-link"
}, [/*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
  "class": "pi pi-fw pi-user"
}), /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, "Profile")], -1);

var _hoisted_5 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("li", null, [/*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
  "class": "p-link"
}, [/*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
  "class": "pi pi-fw pi-inbox"
}), /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, "Notifications"), /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "menuitem-badge"
}, "2")])], -1);

var _hoisted_6 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
  "class": "pi pi-fw pi-power-off"
}, null, -1);

var _hoisted_7 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, "Logout", -1);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_p_avatar = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-avatar");

  var _component_router_link = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("router-link");

  return _ctx.profile ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", null, [_ctx.profile.avatar_url ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_avatar, {
    key: 0,
    image: _ctx.profile.avatar_url,
    size: "xlarge",
    label: ""
  }, null, 8, ["image"])) : (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_avatar, {
    key: 1,
    "class": "p-mb-1",
    label: _ctx.initial,
    shape: "circle",
    size: "xlarge",
    style: {
      "background-color": "#2196F3",
      "color": "#ffffff"
    }
  }, null, 8, ["label"]))]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
    "class": "p-link layout-profile-link",
    onClick: _cache[1] || (_cache[1] = function ($event) {
      return _ctx.toggle();
    })
  }, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", _hoisted_2, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.displayName), 1), _hoisted_3]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Transition"], {
    name: "layout-submenu-wrapper"
  }, {
    "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withDirectives"])(Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("ul", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("li", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_router_link, {
        to: {
          name: 'profile'
        }
      }, {
        "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
          return [_hoisted_4];
        }),
        _: 1
      })]), _hoisted_5, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("li", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
        "class": "p-link",
        onClick: _cache[2] || (_cache[2] = function () {
          return _ctx.logout && _ctx.logout.apply(_ctx, arguments);
        })
      }, [_hoisted_6, _hoisted_7])])], 512), [[external_commonjs_vue_commonjs2_vue_root_Vue_["vShow"], _ctx.expanded]])];
    }),
    _: 1
  })])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true);
}
// CONCATENATED MODULE: ./src/layout/Profile.vue?vue&type=template&id=7346ce04&lang=pug


/***/ }),

/***/ "7853":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Profile_vue_vue_type_template_id_ad76df0c_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("424c");
/* harmony import */ var _Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("e29b");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Profile_vue_vue_type_template_id_ad76df0c_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "78ba":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_hasura_backend_plus_1 = __webpack_require__("f154");

var vue_1 = __webpack_require__("8bbf");

exports["default"] = vue_1.defineComponent({
  name: 'Topbar',
  emits: ['menu-toggle'],
  setup: function setup(_, _ref) {
    var emit = _ref.emit;

    var onMenuToggle = function onMenuToggle(event) {
      emit('menu-toggle', event);
    };

    var connected = vue_hasura_backend_plus_1.useStatus();
    return {
      onMenuToggle: onMenuToggle,
      connected: connected
    };
  }
});

/***/ }),

/***/ "7dda":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadPrimeVue = void 0;

__webpack_require__("0771");

__webpack_require__("9669");

__webpack_require__("7735");

__webpack_require__("014c");

__webpack_require__("2a83");

var accordion_1 = __importDefault(__webpack_require__("1d99"));

var accordiontab_1 = __importDefault(__webpack_require__("639e"));

var autocomplete_1 = __importDefault(__webpack_require__("ebe4"));

var avatar_1 = __importDefault(__webpack_require__("c5f1"));

var breadcrumb_1 = __importDefault(__webpack_require__("4e61"));

var button_1 = __importDefault(__webpack_require__("2789"));

var calendar_1 = __importDefault(__webpack_require__("2f20"));

var card_1 = __importDefault(__webpack_require__("2240"));

var carousel_1 = __importDefault(__webpack_require__("2caa"));

var chart_1 = __importDefault(__webpack_require__("aa7d"));

var checkbox_1 = __importDefault(__webpack_require__("86b6"));

var chip_1 = __importDefault(__webpack_require__("72cb"));

var chips_1 = __importDefault(__webpack_require__("6c9a"));

var colorpicker_1 = __importDefault(__webpack_require__("f1fc"));

var column_1 = __importDefault(__webpack_require__("f96c"));

var columngroup_1 = __importDefault(__webpack_require__("aa10"));

var config_1 = __importDefault(__webpack_require__("11eaf"));

var confirmationservice_1 = __importDefault(__webpack_require__("a08b"));

var confirmdialog_1 = __importDefault(__webpack_require__("c524"));

var contextmenu_1 = __importDefault(__webpack_require__("649c"));

var datatable_1 = __importDefault(__webpack_require__("41ce"));

var dataview_1 = __importDefault(__webpack_require__("5b7c"));

var dataviewlayoutoptions_1 = __importDefault(__webpack_require__("a530"));

var dialog_1 = __importDefault(__webpack_require__("48e9"));

var dropdown_1 = __importDefault(__webpack_require__("c6d1"));

var fieldset_1 = __importDefault(__webpack_require__("7206"));

var fileupload_1 = __importDefault(__webpack_require__("483b"));

var galleria_1 = __importDefault(__webpack_require__("d0f7"));

var inlinemessage_1 = __importDefault(__webpack_require__("fc86"));

var inplace_1 = __importDefault(__webpack_require__("677e"));

var inputmask_1 = __importDefault(__webpack_require__("b195"));

var inputnumber_1 = __importDefault(__webpack_require__("8b24"));

var inputswitch_1 = __importDefault(__webpack_require__("3731"));

var inputtext_1 = __importDefault(__webpack_require__("3a5e"));

var listbox_1 = __importDefault(__webpack_require__("3e0a"));

var megamenu_1 = __importDefault(__webpack_require__("5c42"));

var menu_1 = __importDefault(__webpack_require__("b967"));

var menubar_1 = __importDefault(__webpack_require__("e3b8"));

var message_1 = __importDefault(__webpack_require__("39ea"));

var multiselect_1 = __importDefault(__webpack_require__("bb71"));

var orderlist_1 = __importDefault(__webpack_require__("e888"));

var organizationchart_1 = __importDefault(__webpack_require__("b71c"));

var overlaypanel_1 = __importDefault(__webpack_require__("5d63"));

var paginator_1 = __importDefault(__webpack_require__("2259"));

var panel_1 = __importDefault(__webpack_require__("1b92"));

var panelmenu_1 = __importDefault(__webpack_require__("aa29"));

var password_1 = __importDefault(__webpack_require__("398f"));

var picklist_1 = __importDefault(__webpack_require__("3f7b"));

var progressbar_1 = __importDefault(__webpack_require__("6c30"));

var radiobutton_1 = __importDefault(__webpack_require__("48d4"));

var rating_1 = __importDefault(__webpack_require__("d342"));

var ripple_1 = __importDefault(__webpack_require__("c348"));

var scrolltop_1 = __importDefault(__webpack_require__("e4c2"));

var selectbutton_1 = __importDefault(__webpack_require__("730e"));

var sidebar_1 = __importDefault(__webpack_require__("52d5"));

var slider_1 = __importDefault(__webpack_require__("e385"));

var splitbutton_1 = __importDefault(__webpack_require__("eba7"));

var steps_1 = __importDefault(__webpack_require__("d35ae"));

var tabmenu_1 = __importDefault(__webpack_require__("1a0e"));

var tabpanel_1 = __importDefault(__webpack_require__("4b8e"));

var tabview_1 = __importDefault(__webpack_require__("e0ec"));

var textarea_1 = __importDefault(__webpack_require__("fd51"));

var tieredmenu_1 = __importDefault(__webpack_require__("9ccc"));

var toast_1 = __importDefault(__webpack_require__("47c5"));

var toastservice_1 = __importDefault(__webpack_require__("ea10"));

var togglebutton_1 = __importDefault(__webpack_require__("5b0d"));

var toolbar_1 = __importDefault(__webpack_require__("c162"));

var tooltip_1 = __importDefault(__webpack_require__("a331"));

var tree_1 = __importDefault(__webpack_require__("7955"));

var treetable_1 = __importDefault(__webpack_require__("1e3d"));

var tristatecheckbox_1 = __importDefault(__webpack_require__("440a"));

var loadPrimeVue = function loadPrimeVue(app) {
  app.use(config_1["default"]);
  app.use(toastservice_1["default"]);
  app.use(confirmationservice_1["default"]);
  app.directive('tooltip', tooltip_1["default"]);
  app.directive('ripple', ripple_1["default"]);
  app.component('PAccordion', accordion_1["default"]);
  app.component('PAccordionTab', accordiontab_1["default"]);
  app.component('PAutoComplete', autocomplete_1["default"]);
  app.component('PAvatar', avatar_1["default"]);
  app.component('PBreadcrumb', breadcrumb_1["default"]);
  app.component('PButton', button_1["default"]);
  app.component('PCalendar', calendar_1["default"]);
  app.component('PCard', card_1["default"]);
  app.component('PCarousel', carousel_1["default"]);
  app.component('PChart', chart_1["default"]);
  app.component('PCheckbox', checkbox_1["default"]);
  app.component('PChip', chip_1["default"]);
  app.component('PChips', chips_1["default"]);
  app.component('PColorPicker', colorpicker_1["default"]);
  app.component('PColumn', column_1["default"]);
  app.component('PColumnGroup', columngroup_1["default"]);
  app.component('PConfirmDialog', confirmdialog_1["default"]);
  app.component('PContextMenu', contextmenu_1["default"]);
  app.component('PDataTable', datatable_1["default"]);
  app.component('PDataView', dataview_1["default"]);
  app.component('PDataViewLayoutOptions', dataviewlayoutoptions_1["default"]);
  app.component('PDialog', dialog_1["default"]);
  app.component('PDropdown', dropdown_1["default"]);
  app.component('PFieldset', fieldset_1["default"]);
  app.component('PFileUpload', fileupload_1["default"]);
  app.component('PGalleria', galleria_1["default"]);
  app.component('PInlineMessage', inlinemessage_1["default"]);
  app.component('PInplace', inplace_1["default"]);
  app.component('PInputMask', inputmask_1["default"]);
  app.component('PInputNumber', inputnumber_1["default"]);
  app.component('PInputSwitch', inputswitch_1["default"]);
  app.component('PInputText', inputtext_1["default"]);
  app.component('PListbox', listbox_1["default"]);
  app.component('PMegaMenu', megamenu_1["default"]);
  app.component('PMenu', menu_1["default"]);
  app.component('PMenubar', menubar_1["default"]);
  app.component('PMessage', message_1["default"]);
  app.component('PMultiSelect', multiselect_1["default"]);
  app.component('POrderList', orderlist_1["default"]);
  app.component('POrganizationChart', organizationchart_1["default"]);
  app.component('POverlayPanel', overlaypanel_1["default"]);
  app.component('PPaginator', paginator_1["default"]);
  app.component('PPanel', panel_1["default"]);
  app.component('PPanelMenu', panelmenu_1["default"]);
  app.component('PPassword', password_1["default"]);
  app.component('PPickList', picklist_1["default"]);
  app.component('PProgressBar', progressbar_1["default"]);
  app.component('PRadioButton', radiobutton_1["default"]);
  app.component('PRating', rating_1["default"]);
  app.component('PScrollTop', scrolltop_1["default"]);
  app.component('PSelectButton', selectbutton_1["default"]);
  app.component('PSidebar', sidebar_1["default"]);
  app.component('PSlider', slider_1["default"]);
  app.component('PSplitButton', splitbutton_1["default"]);
  app.component('PSteps', steps_1["default"]);
  app.component('PTabMenu', tabmenu_1["default"]);
  app.component('PTabPanel', tabpanel_1["default"]);
  app.component('PTabView', tabview_1["default"]);
  app.component('PTextarea', textarea_1["default"]);
  app.component('PTieredMenu', tieredmenu_1["default"]);
  app.component('PToast', toast_1["default"]);
  app.component('PToggleButton', togglebutton_1["default"]);
  app.component('PToolbar', toolbar_1["default"]);
  app.component('PTree', tree_1["default"]);
  app.component('PTreeTable', treetable_1["default"]);
  app.component('PTriStateCheckbox', tristatecheckbox_1["default"]);
};

exports.loadPrimeVue = loadPrimeVue;

/***/ }),

/***/ "7e1c":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Menu_vue_vue_type_template_id_15fee5aa_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("1c60");
/* harmony import */ var _Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("0d7c");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Menu_vue_vue_type_template_id_15fee5aa_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_Menu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "80b0":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("52f9");

var _toConsumableArray = __webpack_require__("4615");

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.allRoutes = exports.profileRouts = exports.contentsRoutes = exports.authRoutes = void 0;

var routes_1 = __importDefault(__webpack_require__("b43b"));

exports.authRoutes = routes_1["default"];

var routes_2 = __importDefault(__webpack_require__("cfb3"));

exports.contentsRoutes = routes_2["default"];

var routes_3 = __importDefault(__webpack_require__("d4bf"));

exports.profileRouts = routes_3["default"];
exports.allRoutes = [].concat(_toConsumableArray(routes_1["default"]), _toConsumableArray(routes_2["default"]), _toConsumableArray(routes_3["default"]));

/***/ }),

/***/ "8bbf":
/***/ (function(module, exports) {

module.exports = require("vue");

/***/ }),

/***/ "8ef1":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Register_vue_vue_type_template_id_31f1c1f6_scoped_true_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("ef28");
/* harmony import */ var _Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("d8b0");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var _Register_vue_vue_type_style_index_0_id_31f1c1f6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("662a");





_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Register_vue_vue_type_template_id_31f1c1f6_scoped_true_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]
_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].__scopeId = "data-v-31f1c1f6"

/* harmony default export */ __webpack_exports__["default"] = (_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "9790":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("37c3");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "99c4":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("1c2c");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "9dbc":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/pages/auth/Login.vue?vue&type=template&id=ad4808a6&scoped=true&lang=pug


var _withId = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withScopeId"])("data-v-ad4808a6");

Object(external_commonjs_vue_commonjs2_vue_root_Vue_["pushScopeId"])("data-v-ad4808a6");

var _hoisted_1 = {
  "class": "auth"
};

var _hoisted_2 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("h2", null, "Login", -1);

var _hoisted_3 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("No account yet? ");

var _hoisted_4 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("Sign up");

var _hoisted_5 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("p", null, "Lost password?", -1);

var _hoisted_6 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("Login");

Object(external_commonjs_vue_commonjs2_vue_root_Vue_["popScopeId"])();

var render = /*#__PURE__*/_withId(function (_ctx, _cache, $props, $setup, $data, $options) {
  var _component_router_link = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("router-link");

  var _component_p_input_text = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-input-text");

  var _component_p_button = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-button");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [_hoisted_2, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("form", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("p", null, [_hoisted_3, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_router_link, {
    to: {
      name: 'register'
    }
  }, {
    "default": _withId(function () {
      return [_hoisted_4];
    }),
    _: 1
  })]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_input_text, {
    modelValue: _ctx.email,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return _ctx.email = $event;
    }),
    id: "email",
    type: "text",
    placeholder: "Email",
    autocomplete: "username",
    onKeyup: Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withKeys"])(_ctx.login, ["enter"])
  }, null, 8, ["modelValue", "onKeyup"]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_input_text, {
    modelValue: _ctx.password,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return _ctx.password = $event;
    }),
    id: "password",
    type: "password",
    placeholder: "Password",
    autocomplete: "current-password",
    onKeyup: Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withKeys"])(_ctx.login, ["enter"])
  }, null, 8, ["modelValue", "onKeyup"]), _hoisted_5, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_button, {
    "class": "p-button-rounded",
    onClick: _ctx.login
  }, {
    "default": _withId(function () {
      return [_hoisted_6];
    }),
    _: 1
  }, 8, ["onClick"])]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("p", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.error), 1)]);
});
// CONCATENATED MODULE: ./src/pages/auth/Login.vue?vue&type=template&id=ad4808a6&scoped=true&lang=pug


/***/ }),

/***/ "a288":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Footer_vue_vue_type_template_id_6ad517cc_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("4e27");
/* harmony import */ var _Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("b79f");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Footer_vue_vue_type_template_id_6ad517cc_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "a8d5":
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ "b2c5":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Login_vue_vue_type_template_id_ad4808a6_scoped_true_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("9dbc");
/* harmony import */ var _Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("5c58");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var _Login_vue_vue_type_style_index_0_id_ad4808a6_scoped_true_lang_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("70cf");





_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Login_vue_vue_type_template_id_ad4808a6_scoped_true_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]
_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].__scopeId = "data-v-ad4808a6"

/* harmony default export */ __webpack_exports__["default"] = (_Login_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "b3d5":
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ "b43b":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("8f84");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
var routes = [{
  path: '/login',
  name: 'login',
  component: function component() {
    return Promise.resolve().then(function () {
      return __importStar(__webpack_require__("b2c5"));
    });
  },
  meta: {
    auth: false
  }
}, {
  path: '/register',
  name: 'register',
  component: function component() {
    return Promise.resolve().then(function () {
      return __importStar(__webpack_require__("8ef1"));
    });
  },
  meta: {
    auth: false
  }
}];
exports["default"] = routes;

/***/ }),

/***/ "b79f":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("ce89");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Footer_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "bbb4":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("868d");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("2aa5");

__webpack_require__("32f5");

__webpack_require__("df26");

var _slicedToArray = __webpack_require__("75d5");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var core_1 = __webpack_require__("b6de");

var useconfirm_1 = __webpack_require__("ff6d");

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

var vuex_1 = __webpack_require__("78db");

var composables_1 = __webpack_require__("2746");

exports["default"] = vue_1.defineComponent({
  name: 'DocumentPage',
  props: {
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      "default": undefined
    },
    editing: {
      type: Boolean,
      "default": false
    }
  },
  setup: function setup(props) {
    var _this = this;

    vue_router_1.onBeforeRouteUpdate(function () {});
    vue_router_1.onBeforeRouteLeave(function () {});

    var _core_1$useToggle = core_1.useToggle(),
        _core_1$useToggle2 = _slicedToArray(_core_1$useToggle, 2),
        visibleInfo = _core_1$useToggle2[0],
        toggleInfo = _core_1$useToggle2[1];

    var router = vue_router_1.useRouter();

    var _vue_1$toRefs = vue_1.toRefs(props),
        id = _vue_1$toRefs.id,
        name = _vue_1$toRefs.name;

    var collection = composables_1.useCollection(name);
    var properties = vue_1.computed(function () {
      var _a;

      return (_a = collection.value) === null || _a === void 0 ? void 0 : _a.properties;
    });
    var document = composables_1.useDocument(collection, id);
    var store = vuex_1.useStore();
    var form = vue_1.computed(function () {
      return store.getters['rxdb/form'];
    });

    var read = function read() {
      return document.value && router.replace({
        name: 'document',
        params: {
          collection: props.name,
          id: document.value.primary
        }
      });
    };

    var edit = function edit() {
      return props.id && router.replace({
        name: 'document',
        params: {
          collection: props.name,
          id: props.id,
          action: 'edit'
        }
      });
    };

    var save = function save() {
      return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return store.dispatch('rxdb/save');

              case 2:
                read();

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    };

    var reset = function reset() {
      store.commit('rxdb/reset');
    };

    var cancel = function cancel() {
      reset();
      if (props.id) read();else router.go(-1);
    };

    var confirm = useconfirm_1.useConfirm();

    var remove = function remove() {
      confirm.require({
        message: 'Are you sure you want to remove this document?',
        header: 'Confirmation',
        icon: 'pi pi-info-circle',
        acceptClass: 'p-button-danger',
        accept: function accept() {
          return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var _a;

            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.next = 2;
                    return (_a = document.value) === null || _a === void 0 ? void 0 : _a.remove();

                  case 2:
                    router.go(-1);

                  case 3:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }));
        },
        reject: function reject() {}
      });
    };

    return {
      visibleInfo: visibleInfo,
      toggleInfo: toggleInfo,
      form: form,
      collection: collection,
      properties: properties,
      save: save,
      reset: reset,
      cancel: cancel,
      remove: remove,
      confirm: confirm,
      edit: edit,
      document: document
    };
  }
});

/***/ }),

/***/ "be53":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_style_index_0_id_7346ce04_lang_css__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("b3d5");
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_style_index_0_id_7346ce04_lang_css__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_v16_dist_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_style_index_0_id_7346ce04_lang_css__WEBPACK_IMPORTED_MODULE_0__);
/* unused harmony reexport * */


/***/ }),

/***/ "c678":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Submenu_vue_vue_type_template_id_358e41c2_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("4283");
/* harmony import */ var _Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("99c4");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Submenu_vue_vue_type_template_id_358e41c2_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_Submenu_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "ce89":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = {
  name: 'Footer'
};

/***/ }),

/***/ "cfb3":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("868d");

__webpack_require__("8f84");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
var routes = [{
  path: '/collection/:name/:action?',
  name: 'collection',
  component: function component() {
    return Promise.resolve().then(function () {
      return __importStar(__webpack_require__("02b7"));
    });
  },
  props: function props(route) {
    return {
      name: route.params.name,
      editing: route.params.action === 'edit'
    };
  },
  meta: {
    auth: true
  }
}, {
  path: '/document/:collection/new',
  name: 'newDocument',
  component: function component() {
    return Promise.resolve().then(function () {
      return __importStar(__webpack_require__("2037"));
    });
  },
  props: function props(route) {
    return {
      name: route.params.collection,
      editing: true
    };
  },
  meta: {
    auth: true
  }
}, {
  path: '/document/:collection/:id/:action?',
  name: 'document',
  component: function component() {
    return Promise.resolve().then(function () {
      return __importStar(__webpack_require__("2037"));
    });
  },
  props: function props(route) {
    return {
      name: route.params.collection,
      id: route.params.id,
      editing: route.params.action === 'edit'
    };
  },
  meta: {
    auth: true
  }
}];
exports["default"] = routes;

/***/ }),

/***/ "d34f":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/core-js/modules/es.symbol.js
var es_symbol = __webpack_require__("d6de");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/core-js/modules/es.symbol.description.js
var es_symbol_description = __webpack_require__("8d0f");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/core-js/modules/es.function.name.js
var es_function_name = __webpack_require__("868d");

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/pages/contents/CollectionPage.vue?vue&type=template&id=80abdbf4&lang=pug




var _hoisted_1 = {
  key: 0,
  "class": "card"
};
var _hoisted_2 = {
  key: 1,
  "class": "card"
};
var _hoisted_3 = {
  key: 2,
  "class": "card"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _ctx$collection;

  var _component_p_button = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-button");

  var _component_p_toolbar = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-toolbar");

  var _component_h_collection = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("h-collection");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(external_commonjs_vue_commonjs2_vue_root_Vue_["Fragment"], null, [_ctx.collection ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("h3", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("i", {
    "class": ["p-mr-2", _ctx.collection.icon()]
  }, null, 2), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.collection.title()), 1)]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("p", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.collection.description()), 1), _ctx.canEdit ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_toolbar, {
    key: 0,
    "class": "p-mb-4"
  }, {
    left: Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [!_ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 0,
        "class": "p-mr-2",
        icon: "pi pi-pencil",
        label: "Edit",
        onClick: _ctx.edit
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), !_ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 1,
        "class": "p-mr-2",
        icon: "pi pi-plus",
        label: "Create",
        onClick: _ctx.create
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 2,
        "class": "p-mr-2",
        icon: "pi pi-save",
        label: "Save",
        onClick: _ctx.save
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 3,
        "class": "p-mr-2",
        icon: "pi pi-undo",
        label: "Reset",
        onClick: _ctx.reset
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_p_button, {
        key: 4,
        "class": "p-mr-2",
        icon: "pi pi-times",
        label: "Cancel",
        onClick: _ctx.cancel
      }, null, 8, ["onClick"])) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)];
    }),
    _: 1
  })) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_h_collection, {
    key: _ctx.collection.name,
    collection: _ctx.collection,
    type: _ctx.collection.defaultView(),
    editing: _ctx.editing
  }, null, 8, ["collection", "type", "editing"])])) : (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_2, "loading collection...")), (_ctx$collection = _ctx.collection) !== null && _ctx$collection !== void 0 && _ctx$collection.canUpdate() && _ctx.editing ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_3, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.form), 1)) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)], 64);
}
// CONCATENATED MODULE: ./src/pages/contents/CollectionPage.vue?vue&type=template&id=80abdbf4&lang=pug


/***/ }),

/***/ "d4bf":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("8f84");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
var routes = [{
  path: '/profile/:action?',
  name: 'profile',
  component: function component() {
    return Promise.resolve().then(function () {
      return __importStar(__webpack_require__("7853"));
    });
  },
  props: function props(route) {
    return {
      editing: route.params.action === 'edit'
    };
  },
  meta: {
    auth: true
  }
}];
exports["default"] = routes;

/***/ }),

/***/ "d8b0":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("5d48");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Register_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "e094":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _Topbar_vue_vue_type_template_id_2eb86a57_lang_pug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("f616");
/* harmony import */ var _Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("2d12");
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__[key]; }) }(__WEBPACK_IMPORT_KEY__));



_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"].render = _Topbar_vue_vue_type_template_id_2eb86a57_lang_pug__WEBPACK_IMPORTED_MODULE_0__[/* render */ "a"]

/* harmony default export */ __webpack_exports__["default"] = (_Topbar_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_1__["default"]);

/***/ }),

/***/ "e29b":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("1f8a");
/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__);
/* harmony reexport (default from non-harmony) */ __webpack_require__.d(__webpack_exports__, "default", function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0___default.a; });
/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__) if(["default"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_thread_loader_dist_cjs_js_node_modules_babel_loader_lib_index_js_node_modules_ts_loader_index_js_ref_13_3_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_v16_dist_index_js_ref_0_1_Profile_vue_vue_type_script_lang_ts__WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));
 

/***/ }),

/***/ "e792":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("2aa5");

__webpack_require__("32f5");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var vue_hasura_backend_plus_1 = __webpack_require__("f154");

var vue_1 = __webpack_require__("8bbf");

var vue_router_1 = __webpack_require__("9c2b");

exports["default"] = vue_1.defineComponent({
  name: 'Login',
  setup: function setup() {
    var _this = this;

    var router = vue_router_1.useRouter();
    var route = vue_router_1.useRoute();
    var email = vue_1.ref('');
    var password = vue_1.ref('');

    var _vue_hasura_backend_p = vue_hasura_backend_plus_1.useLogin(email, password),
        hbpLogin = _vue_hasura_backend_p.login,
        error = _vue_hasura_backend_p.error;

    var login = function login() {
      return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return hbpLogin();

              case 2:
                if (!error.value) router.replace(route.redirectedFrom || {
                  name: 'home'
                });

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    };

    return {
      email: email,
      password: password,
      login: login,
      error: error
    };
  }
});

/***/ }),

/***/ "e874":
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ "ef28":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/pages/auth/Register.vue?vue&type=template&id=31f1c1f6&scoped=true&lang=pug


var _withId = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withScopeId"])("data-v-31f1c1f6");

Object(external_commonjs_vue_commonjs2_vue_root_Vue_["pushScopeId"])("data-v-31f1c1f6");

var _hoisted_1 = {
  "class": "auth"
};

var _hoisted_2 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("h2", null, "Register", -1);

var _hoisted_3 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("Already have an account? ");

var _hoisted_4 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("Login");

var _hoisted_5 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createTextVNode"])("Register");

Object(external_commonjs_vue_commonjs2_vue_root_Vue_["popScopeId"])();

var render = /*#__PURE__*/_withId(function (_ctx, _cache, $props, $setup, $data, $options) {
  var _component_router_link = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("router-link");

  var _component_p_input_text = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-input-text");

  var _component_p_button = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-button");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [_hoisted_2, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("form", null, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("p", null, [_hoisted_3, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_router_link, {
    to: {
      name: 'login'
    }
  }, {
    "default": _withId(function () {
      return [_hoisted_4];
    }),
    _: 1
  })]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_input_text, {
    modelValue: _ctx.email,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return _ctx.email = $event;
    }),
    id: "email",
    type: "text",
    placeholder: "Email",
    autocomplete: "username"
  }, null, 8, ["modelValue"]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_input_text, {
    modelValue: _ctx.password,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return _ctx.password = $event;
    }),
    id: "password",
    type: "password",
    placeholder: "Password",
    autocomplete: "current-password"
  }, null, 8, ["modelValue"]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_button, {
    "class": "p-button-rounded",
    onClick: _ctx.registerUser
  }, {
    "default": _withId(function () {
      return [_hoisted_5];
    }),
    _: 1
  }, 8, ["onClick"])]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("p", null, Object(external_commonjs_vue_commonjs2_vue_root_Vue_["toDisplayString"])(_ctx.error), 1)]);
});
// CONCATENATED MODULE: ./src/pages/auth/Register.vue?vue&type=template&id=31f1c1f6&scoped=true&lang=pug


/***/ }),

/***/ "f616":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* reexport */ render; });

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--12-0!/Users/pilou/dev/platyplus/platydev/node_modules/thread-loader/dist/cjs.js!/Users/pilou/dev/platyplus/platydev/node_modules/babel-loader/lib!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist/templateLoader.js??ref--6!/Users/pilou/dev/platyplus/platydev/node_modules/pug-plain-loader!/Users/pilou/dev/platyplus/platydev/node_modules/cache-loader/dist/cjs.js??ref--0-0!/Users/pilou/dev/platyplus/platydev/node_modules/vue-loader-v16/dist??ref--0-1!./src/layout/Topbar.vue?vue&type=template&id=2eb86a57&lang=pug

var _hoisted_1 = {
  "class": "layout-topbar"
};

var _hoisted_2 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "pi pi-bars"
}, null, -1);

var _hoisted_3 = {
  "class": "layout-topbar-icons"
};
var _hoisted_4 = {
  "class": "layout-topbar-search"
};

var _hoisted_5 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-search-icon pi pi-search"
}, null, -1);

var _hoisted_6 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
  "class": "p-link"
}, [/*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-item-text"
}, "Events"), /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-icon pi pi-calendar"
}), /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-badge"
}, "5")], -1);

var _hoisted_7 = {
  key: 0,
  "class": "p-link"
};

var _hoisted_8 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-item-text"
}, "Settings", -1);

var _hoisted_9 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-icon pi pi-cog"
}, null, -1);

var _hoisted_10 = /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
  "class": "p-link"
}, [/*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-item-text"
}, "User"), /*#__PURE__*/Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", {
  "class": "layout-topbar-icon pi pi-user"
})], -1);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_p_input_text = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("p-input-text");

  var _component_router_link = Object(external_commonjs_vue_commonjs2_vue_root_Vue_["resolveComponent"])("router-link");

  return Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])("div", _hoisted_1, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("button", {
    "class": "p-link layout-menu-button",
    onClick: _cache[1] || (_cache[1] = function () {
      return _ctx.onMenuToggle && _ctx.onMenuToggle.apply(_ctx, arguments);
    })
  }, [_hoisted_2]), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("div", _hoisted_3, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])("span", _hoisted_4, [Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createVNode"])(_component_p_input_text, {
    type: "text",
    placeholder: "Search"
  }, {
    "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [_hoisted_5];
    }),
    _: 1
  })]), _hoisted_6, false ? (undefined) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true), _ctx.connected ? (Object(external_commonjs_vue_commonjs2_vue_root_Vue_["openBlock"])(), Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createBlock"])(_component_router_link, {
    key: 1,
    to: {
      name: 'profile'
    }
  }, {
    "default": Object(external_commonjs_vue_commonjs2_vue_root_Vue_["withCtx"])(function () {
      return [_hoisted_10];
    }),
    _: 1
  })) : Object(external_commonjs_vue_commonjs2_vue_root_Vue_["createCommentVNode"])("", true)])]);
}
// CONCATENATED MODULE: ./src/layout/Topbar.vue?vue&type=template&id=2eb86a57&lang=pug


/***/ })

/******/ });
//# sourceMappingURL=vue-rxdb-hasura.common.js.map