((typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] || []).push([[36],{

/***/ "00e8":
/***/ (function(module, exports) {


//# sourceMappingURL=graphql-client.d.js.map

/***/ }),

/***/ "02aa":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "p", function() { return pluginMissing; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return fastUnsecureHash; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return RXDB_HASH_SALT; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "j", function() { return hash; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return generateId; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "n", function() { return now; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "m", function() { return nextTick; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "r", function() { return promiseWait; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "z", function() { return toPromise; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "v", function() { return requestIdlePromise; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "q", function() { return promiseSeries; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "u", function() { return requestIdleCallbackIfAvailable; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "B", function() { return ucfirst; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "A", function() { return trimDots; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "x", function() { return sortObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "y", function() { return stringifyFilter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "s", function() { return randomCouchString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "w", function() { return shuffleArray; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "t", function() { return removeOneFromArrayIfMatches; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return adapterObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return clone; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return flatClone; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "k", function() { return isElectronRenderer; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return flattenObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "i", function() { return getHeightOfRevision; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LOCAL_PREFIX; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "o", function() { return overwriteGetterForCaching; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "l", function() { return isFolderPath; });
/* harmony import */ var random_token__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("f1a6");
/* harmony import */ var random_token__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(random_token__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var clone__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("f569");
/* harmony import */ var clone__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(clone__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var spark_md5__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("4bc0");
/* harmony import */ var spark_md5__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(spark_md5__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var is_electron__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("4010");
/* harmony import */ var is_electron__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(is_electron__WEBPACK_IMPORTED_MODULE_3__);
/**
 * this contains a mapping to basic dependencies
 * which should be easy to change
 */


/**
 * Returns an error that indicates that a plugin is missing
 * We do not throw a RxError because this should not be handled
 * programmatically but by using the correct import
 */

function pluginMissing(pluginKey) {
  var keyParts = pluginKey.split('-');
  var pluginName = 'RxDB';
  keyParts.forEach(function (part) {
    pluginName += ucfirst(part);
  });
  pluginName += 'Plugin';
  return new Error("You are using a function which must be overwritten by a plugin.\n        You should either prevent the usage of this function or add the plugin via:\n            import { " + pluginName + " } from 'rxdb/plugins/" + pluginKey + "';\n            addRxPlugin(" + pluginName + ");\n        ");
}
/**
 * this is a very fast hashing but its unsecure
 * @link http://stackoverflow.com/questions/7616461/generate-a-hash-from-string-in-javascript-jquery
 * @return a number as hash-result
 */

function fastUnsecureHash(obj) {
  if (typeof obj !== 'string') obj = JSON.stringify(obj);
  var hashValue = 0,
      i,
      chr,
      len;
  if (obj.length === 0) return hashValue;

  for (i = 0, len = obj.length; i < len; i++) {
    chr = obj.charCodeAt(i); // tslint:disable-next-line

    hashValue = (hashValue << 5) - hashValue + chr; // tslint:disable-next-line

    hashValue |= 0; // Convert to 32bit integer
  }

  if (hashValue < 0) hashValue = hashValue * -1;
  return hashValue;
}
/**
 * Does a RxDB-specific hashing of the given data.
 * We use a static salt so using a rainbow-table
 * or google-ing the hash will not work.
 *
 * spark-md5 is used here
 * because pouchdb uses the same
 * and build-size could be reduced by 9kb
 */


var RXDB_HASH_SALT = 'rxdb-specific-hash-salt';
function hash(msg) {
  if (typeof msg !== 'string') {
    msg = JSON.stringify(msg);
  }

  return spark_md5__WEBPACK_IMPORTED_MODULE_2___default.a.hash(RXDB_HASH_SALT + msg);
}
/**
 * generate a new _id as db-primary-key
 */

function generateId() {
  return random_token__WEBPACK_IMPORTED_MODULE_0___default()(10) + ':' + now();
}
/**
 * Returns the current unix time in milliseconds
 * Because the accuracy of getTime() in javascript is bad,
 * and we cannot rely on performance.now() on all plattforms,
 * this method implements a way to never return the same value twice.
 * This ensures that when now() is called often, we do not loose the information
 * about which call came first and which came after.
 * Caution: Do not call this too often in a short timespan
 * because it might return 'the future'
 */

var _lastNow = 0;
function now() {
  var ret = new Date().getTime();

  if (ret <= _lastNow) {
    ret = _lastNow + 1;
  }

  _lastNow = ret;
  return ret;
}
/**
 * returns a promise that resolves on the next tick
 */

function nextTick() {
  return new Promise(function (res) {
    return setTimeout(res, 0);
  });
}
function promiseWait() {
  var ms = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  return new Promise(function (res) {
    return setTimeout(res, ms);
  });
}
function toPromise(maybePromise) {
  if (maybePromise && typeof maybePromise.then === 'function') {
    // is promise
    return maybePromise;
  } else {
    return Promise.resolve(maybePromise);
  }
}
function requestIdlePromise() {
  var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  if (typeof window === 'object' && window['requestIdleCallback']) {
    return new Promise(function (res) {
      return window['requestIdleCallback'](res, {
        timeout: timeout
      });
    });
  } else return Promise.resolve();
}
/**
 * like Promise.all() but runs in series instead of parallel
 * @link https://github.com/egoist/promise.series/blob/master/index.js
 * @param tasks array with functions that return a promise
 */

function promiseSeries(tasks, initial) {
  return tasks.reduce(function (current, next) {
    return current.then(next);
  }, Promise.resolve(initial));
}
/**
 * run the callback if requestIdleCallback available
 * do nothing if not
 * @link https://developer.mozilla.org/de/docs/Web/API/Window/requestIdleCallback
 */

function requestIdleCallbackIfAvailable(fun) {
  if (typeof window === 'object' && window['requestIdleCallback']) window['requestIdleCallback'](fun);
}
/**
 * uppercase first char
 */

function ucfirst(str) {
  str += '';
  var f = str.charAt(0).toUpperCase();
  return f + str.substr(1);
}
/**
 * removes trailing and ending dots from the string
 */

function trimDots(str) {
  // start
  while (str.charAt(0) === '.') {
    str = str.substr(1);
  } // end


  while (str.slice(-1) === '.') {
    str = str.slice(0, -1);
  }

  return str;
}
/**
 * deep-sort an object so its attributes are in lexical order.
 * Also sorts the arrays inside of the object if no-array-sort not set
 */

function sortObject(obj) {
  var noArraySort = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  if (!obj) return obj; // do not sort null, false or undefined
  // array

  if (!noArraySort && Array.isArray(obj)) {
    return obj.sort(function (a, b) {
      if (typeof a === 'string' && typeof b === 'string') return a.localeCompare(b);
      if (typeof a === 'object') return 1;else return -1;
    }).map(function (i) {
      return sortObject(i, noArraySort);
    });
  } // object
  // array is also of type object


  if (typeof obj === 'object' && !Array.isArray(obj)) {
    if (obj instanceof RegExp) return obj;
    var out = {};
    Object.keys(obj).sort(function (a, b) {
      return a.localeCompare(b);
    }).forEach(function (key) {
      out[key] = sortObject(obj[key], noArraySort);
    });
    return out;
  } // everything else


  return obj;
}
/**
 * used to JSON.stringify() objects that contain a regex
 * @link https://stackoverflow.com/a/33416684 thank you Fabian Jakobs!
 */

function stringifyFilter(key, value) {
  if (value instanceof RegExp) return value.toString();
  return value;
}
/**
 * get a random string which can be used with couchdb
 * @link http://stackoverflow.com/a/1349426/3443137
 */

function randomCouchString() {
  var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
  var text = '';
  var possible = 'abcdefghijklmnopqrstuvwxyz';

  for (var i = 0; i < length; i++) {
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  }

  return text;
}
/**
 * shuffle the given array
 */

function shuffleArray(arr) {
  return arr.sort(function () {
    return Math.random() - 0.5;
  });
}
/**
 * @link https://stackoverflow.com/a/15996017
 */

function removeOneFromArrayIfMatches(ar, condition) {
  ar = ar.slice();
  var i = ar.length;
  var done = false;

  while (i-- && !done) {
    if (condition(ar[i])) {
      done = true;
      ar.splice(i, 1);
    }
  }

  return ar;
}
/**
 * transforms the given adapter into a pouch-compatible object
 */

function adapterObject(adapter) {
  var adapterObj = {
    db: adapter
  };

  if (typeof adapter === 'string') {
    adapterObj = {
      adapter: adapter
    };
  }

  return adapterObj;
}

function recursiveDeepCopy(o) {
  if (!o) return o;
  return clone__WEBPACK_IMPORTED_MODULE_1___default()(o, false);
}

var clone = recursiveDeepCopy;
/**
 * does a flat copy on the objects,
 * is about 3 times faster then using deepClone
 * @link https://jsperf.com/object-rest-spread-vs-clone/2
 */

function flatClone(obj) {
  return Object.assign({}, obj);
}

var isElectronRenderer = is_electron__WEBPACK_IMPORTED_MODULE_3___default()();
/**
 * returns a flattened object
 * @link https://gist.github.com/penguinboy/762197
 */

function flattenObject(ob) {
  var toReturn = {};

  for (var i in ob) {
    if (!ob.hasOwnProperty(i)) continue;

    if (typeof ob[i] === 'object') {
      var flatObject = flattenObject(ob[i]);

      for (var _x in flatObject) {
        if (!flatObject.hasOwnProperty(_x)) continue;
        toReturn[i + '.' + _x] = flatObject[_x];
      }
    } else {
      toReturn[i] = ob[i];
    }
  }

  return toReturn;
}
function getHeightOfRevision(revString) {
  var first = revString.split('-')[0];
  return parseInt(first, 10);
}
/**
 * prefix of local pouchdb documents
 */

var LOCAL_PREFIX = '_local/';
/**
 * overwrites the getter with the actual value
 * Mostly used for caching stuff on the first run
 */

function overwriteGetterForCaching(obj, getterName, value) {
  Object.defineProperty(obj, getterName, {
    get: function get() {
      return value;
    }
  });
  return value;
}
/**
 * returns true if the given name is likely a folder path
 */

function isFolderPath(name) {
  // do not check, if foldername is given
  if (name.includes('/') || // unix
  name.includes('\\') // windows
  ) {
      return true;
    } else {
    return false;
  }
}
//# sourceMappingURL=util.js.map

/***/ }),

/***/ "11ea":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RxCollectionBase; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return create; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return isInstanceOf; });
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("56d4");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("71b8");
/* harmony import */ var _babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("63d2");
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("cf9c");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("5bf3");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("e076");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("260e");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("02a2");
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("02aa");
/* harmony import */ var _pouch_db__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("d79b");
/* harmony import */ var _rx_collection_helper__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("352c");
/* harmony import */ var _rx_query__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("7559");
/* harmony import */ var _rx_schema__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("ab32");
/* harmony import */ var _rx_change_event__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("c9cd");
/* harmony import */ var _rx_error__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__("7733");
/* harmony import */ var _crypter__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__("d37f");
/* harmony import */ var _doc_cache__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__("7ed4");
/* harmony import */ var _query_cache__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__("c427");
/* harmony import */ var _change_event_buffer__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__("cff2");
/* harmony import */ var _overwritable__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__("e73d");
/* harmony import */ var _hooks__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__("ac6e");
/* harmony import */ var _rx_document__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__("6c14");
/* harmony import */ var _rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__("2a87");



















var HOOKS_WHEN = ['pre', 'post'];
var HOOKS_KEYS = ['insert', 'save', 'remove', 'create'];
var hooksApplied = false;
var RxCollectionBase = /*#__PURE__*/function () {
  function RxCollectionBase(database, name, schema) {
    var pouchSettings = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var migrationStrategies = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    var methods = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    var attachments = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};
    var options = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : {};
    var cacheReplacementPolicy = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : _query_cache__WEBPACK_IMPORTED_MODULE_17__[/* defaultCacheReplacementPolicy */ "i"];
    var statics = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : {};
    this._isInMemory = false;
    this.destroyed = false;
    this._atomicUpsertQueues = new Map();
    this.synced = false;
    this.hooks = {};
    this._subs = [];
    this._repStates = [];
    this.pouch = {};
    this._docCache = Object(_doc_cache__WEBPACK_IMPORTED_MODULE_16__[/* createDocCache */ "a"])();
    this._queryCache = Object(_query_cache__WEBPACK_IMPORTED_MODULE_17__[/* createQueryCache */ "h"])();
    this._crypter = {};
    this._changeEventBuffer = {};
    this.database = database;
    this.name = name;
    this.schema = schema;
    this.pouchSettings = pouchSettings;
    this.migrationStrategies = migrationStrategies;
    this.methods = methods;
    this.attachments = attachments;
    this.options = options;
    this.cacheReplacementPolicy = cacheReplacementPolicy;
    this.statics = statics;

    _applyHookFunctions(this.asRxCollection);
  }
  /**
   * returns observable
   */


  var _proto = RxCollectionBase.prototype;

  _proto.prepare = function prepare(
  /**
   * set to true if the collection data already exists on this storage adapter
   */
  wasCreatedBefore) {
    var _this = this;

    this.pouch = this.database._spawnPouchDB(this.name, this.schema.version, this.pouchSettings);

    if (this.schema.doKeyCompression()) {
      this._keyCompressor = _overwritable__WEBPACK_IMPORTED_MODULE_19__[/* overwritable */ "a"].createKeyCompressor(this.schema);
    } // we trigger the non-blocking things first and await them later so we can do stuff in the mean time

    /**
     * Sometimes pouchdb emits before the instance is useable.
     * To prevent random errors, we wait until the .info() call resolved
     */


    var spawnedPouchPromise = wasCreatedBefore ? Promise.resolve() : this.pouch.info();
    /**
     * if wasCreatedBefore we can assume that the indexes already exist
     * because changing them anyway requires a schema-version change
     */

    var createIndexesPromise = wasCreatedBefore ? Promise.resolve() : _prepareCreateIndexes(this.asRxCollection, spawnedPouchPromise);
    this._crypter = Object(_crypter__WEBPACK_IMPORTED_MODULE_15__[/* createCrypter */ "b"])(this.database.password, this.schema);
    this._observable$ = this.database.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_3__[/* filter */ "a"])(function (event) {
      return event.collectionName === _this.name;
    }));
    this._changeEventBuffer = Object(_change_event_buffer__WEBPACK_IMPORTED_MODULE_18__[/* createChangeEventBuffer */ "a"])(this.asRxCollection);

    this._subs.push(this._observable$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_3__[/* filter */ "a"])(function (cE) {
      return !cE.isLocal;
    })).subscribe(function (cE) {
      // when data changes, send it to RxDocument in docCache
      var doc = _this._docCache.get(cE.documentId);

      if (doc) doc._handleChangeEvent(cE);
    }));

    return Promise.all([spawnedPouchPromise, createIndexesPromise]);
  } // overwritte by migration-plugin
  ;

  _proto.migrationNeeded = function migrationNeeded() {
    if (this.schema.version === 0) {
      return Promise.resolve(false);
    }

    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('migration');
  };

  _proto.getDataMigrator = function getDataMigrator() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('migration');
  };

  _proto.migrate = function migrate() {
    var batchSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
    return this.getDataMigrator().migrate(batchSize);
  };

  _proto.migratePromise = function migratePromise() {
    var batchSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
    return this.getDataMigrator().migratePromise(batchSize);
  }
  /**
   * wrappers for Pouch.put/get to handle keycompression etc
   */
  ;

  _proto._handleToPouch = function _handleToPouch(docData) {
    return Object(_rx_collection_helper__WEBPACK_IMPORTED_MODULE_10__[/* _handleToPouch */ "b"])(this, docData);
  };

  _proto._handleFromPouch = function _handleFromPouch(docData) {
    var noDecrypt = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    return Object(_rx_collection_helper__WEBPACK_IMPORTED_MODULE_10__[/* _handleFromPouch */ "a"])(this, docData, noDecrypt);
  }
  /**
   * every write on the pouchdb
   * is tunneld throught this function
   */
  ;

  _proto._pouchPut = function _pouchPut(obj) {
    var _this2 = this;

    var overwrite = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    obj = this._handleToPouch(obj);
    return this.database.lockedRun(function () {
      return _this2.pouch.put(obj);
    })["catch"](function (err) {
      if (overwrite && err.status === 409) {
        return _this2.database.lockedRun(function () {
          return _this2.pouch.get(obj._id);
        }).then(function (exist) {
          obj._rev = exist._rev;
          return _this2.database.lockedRun(function () {
            return _this2.pouch.put(obj);
          });
        });
      } else if (err.status === 409) {
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL19', {
          id: obj._id,
          pouchDbError: err,
          data: obj
        });
      } else throw err;
    });
  }
  /**
   * get document from pouchdb by its _id
   */
  ;

  _proto._pouchGet = function _pouchGet(key) {
    var _this3 = this;

    return this.pouch.get(key).then(function (doc) {
      return _this3._handleFromPouch(doc);
    });
  }
  /**
   * wrapps pouch-find
   */
  ;

  _proto._pouchFind = function _pouchFind(rxQuery, limit) {
    var _this4 = this;

    var noDecrypt = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var compressedQueryJSON = rxQuery.keyCompress();

    if (limit) {
      compressedQueryJSON['limit'] = limit;
    }

    return this.database.lockedRun(function () {
      return _this4.pouch.find(compressedQueryJSON);
    }).then(function (docsCompressed) {
      var docs = docsCompressed.docs.map(function (doc) {
        return _this4._handleFromPouch(doc, noDecrypt);
      });
      return docs;
    });
  };

  _proto.$emit = function $emit(changeEvent) {
    return this.database.$emit(changeEvent);
  };

  _proto.insert = function insert(json) {
    var _this5 = this;

    // inserting a temporary-document
    var tempDoc = null;

    if (Object(_rx_document__WEBPACK_IMPORTED_MODULE_21__[/* isInstanceOf */ "e"])(json)) {
      tempDoc = json;

      if (!tempDoc._isTemporary) {
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL1', {
          data: json
        });
      }

      json = tempDoc.toJSON();
    }

    var useJson = Object(_rx_collection_helper__WEBPACK_IMPORTED_MODULE_10__[/* fillObjectDataBeforeInsert */ "c"])(this, json);
    var newDoc = tempDoc;
    var startTime;
    var endTime;
    return this._runHooks('pre', 'insert', useJson).then(function () {
      _this5.schema.validate(useJson);

      startTime = Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* now */ "n"])();
      return _this5._pouchPut(useJson);
    }).then(function (insertResult) {
      endTime = Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* now */ "n"])();
      useJson[_this5.schema.primaryPath] = insertResult.id;
      useJson._rev = insertResult.rev;

      if (tempDoc) {
        tempDoc._dataSync$.next(useJson);
      } else newDoc = Object(_rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_22__[/* createRxDocument */ "a"])(_this5, useJson);

      return _this5._runHooks('post', 'insert', useJson, newDoc);
    }).then(function () {
      // event
      var emitEvent = Object(_rx_change_event__WEBPACK_IMPORTED_MODULE_13__[/* createInsertEvent */ "d"])(_this5, useJson, startTime, endTime, newDoc);

      _this5.$emit(emitEvent);

      return newDoc;
    });
  };

  _proto.bulkInsert = function bulkInsert(docsData) {
    var _this6 = this;

    var useDocs = docsData.map(function (docData) {
      var useDocData = Object(_rx_collection_helper__WEBPACK_IMPORTED_MODULE_10__[/* fillObjectDataBeforeInsert */ "c"])(_this6, docData);
      return useDocData;
    });
    return Promise.all(useDocs.map(function (doc) {
      return _this6._runHooks('pre', 'insert', doc).then(function () {
        _this6.schema.validate(doc);

        return doc;
      });
    })).then(function (docs) {
      var insertDocs = docs.map(function (d) {
        return _this6._handleToPouch(d);
      });
      var docsMap = new Map();
      docs.forEach(function (d) {
        docsMap.set(d[_this6.schema.primaryPath], d);
      });
      return _this6.database.lockedRun(function () {
        var startTime = Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* now */ "n"])();
        return _this6.pouch.bulkDocs(insertDocs).then(function (results) {
          var okResults = results.filter(function (r) {
            return r.ok;
          }); // create documents

          var rxDocuments = okResults.map(function (r) {
            var docData = docsMap.get(r.id);
            docData._rev = r.rev;
            var doc = Object(_rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_22__[/* createRxDocument */ "a"])(_this6, docData);
            return doc;
          });
          return Promise.all(rxDocuments.map(function (doc) {
            return _this6._runHooks('post', 'insert', docsMap.get(doc.primary), doc);
          })).then(function () {
            return {
              rxDocuments: rxDocuments,
              errorResults: results.filter(function (r) {
                return !r.ok;
              })
            };
          });
        }).then(function (_ref) {
          var rxDocuments = _ref.rxDocuments,
              errorResults = _ref.errorResults;
          var endTime = Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* now */ "n"])(); // emit events

          rxDocuments.forEach(function (doc) {
            var emitEvent = Object(_rx_change_event__WEBPACK_IMPORTED_MODULE_13__[/* createInsertEvent */ "d"])(_this6, doc.toJSON(true), startTime, endTime, doc);

            _this6.$emit(emitEvent);
          });
          return {
            success: rxDocuments,
            error: errorResults
          };
        });
      });
    });
  }
  /**
   * same as insert but overwrites existing document with same primary
   */
  ;

  _proto.upsert = function upsert(json) {
    var _this7 = this;

    var useJson = Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* flatClone */ "f"])(json);
    var primary = useJson[this.schema.primaryPath];

    if (!primary) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL3', {
        primaryPath: this.schema.primaryPath,
        data: useJson
      });
    }

    return this.findOne(primary).exec().then(function (existing) {
      if (existing) {
        useJson._rev = existing['_rev'];
        return existing.atomicUpdate(function () {
          return useJson;
        }).then(function () {
          return existing;
        });
      } else {
        return _this7.insert(json);
      }
    });
  }
  /**
   * upserts to a RxDocument, uses atomicUpdate if document already exists
   */
  ;

  _proto.atomicUpsert = function atomicUpsert(json) {
    var _this8 = this;

    var primary = json[this.schema.primaryPath];

    if (!primary) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL4', {
        data: json
      });
    } // ensure that it wont try 2 parallel runs


    var queue;

    if (!this._atomicUpsertQueues.has(primary)) {
      queue = Promise.resolve();
    } else {
      queue = this._atomicUpsertQueues.get(primary);
    }

    queue = queue.then(function () {
      return _atomicUpsertEnsureRxDocumentExists(_this8, primary, json);
    }).then(function (wasInserted) {
      if (!wasInserted.inserted) {
        return _atomicUpsertUpdate(wasInserted.doc, json).then(function () {
          return Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* nextTick */ "m"])();
        }) // tick here so the event can propagate
        .then(function () {
          return wasInserted.doc;
        });
      } else return wasInserted.doc;
    });

    this._atomicUpsertQueues.set(primary, queue);

    return queue;
  };

  _proto.find = function find(queryObj) {
    if (typeof queryObj === 'string') {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL5', {
        queryObj: queryObj
      });
    }

    if (!queryObj) {
      queryObj = Object(_rx_query__WEBPACK_IMPORTED_MODULE_11__[/* _getDefaultQuery */ "b"])(this);
    }

    var query = Object(_rx_query__WEBPACK_IMPORTED_MODULE_11__[/* createRxQuery */ "c"])('find', queryObj, this);
    return query;
  };

  _proto.findOne = function findOne(queryObj) {
    var query;

    if (typeof queryObj === 'string') {
      query = Object(_rx_query__WEBPACK_IMPORTED_MODULE_11__[/* createRxQuery */ "c"])('findOne', {
        selector: {
          _id: queryObj
        }
      }, this);
    } else {
      if (!queryObj) {
        queryObj = Object(_rx_query__WEBPACK_IMPORTED_MODULE_11__[/* _getDefaultQuery */ "b"])(this);
      } // cannot have limit on findOne queries


      if (queryObj.limit) {
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('QU6');
      }

      query = Object(_rx_query__WEBPACK_IMPORTED_MODULE_11__[/* createRxQuery */ "c"])('findOne', queryObj, this);
    }

    if (typeof queryObj === 'number' || Array.isArray(queryObj)) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxTypeError */ "c"])('COL6', {
        queryObj: queryObj
      });
    }

    return query;
  }
  /**
   * find a list documents by their primary key
   * has way better performance then running multiple findOne() or a find() with a complex $or-selected
   */
  ;

  _proto.findByIds =
  /*#__PURE__*/
  function () {
    var _findByIds = _babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1___default()( /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default.a.mark(function _callee(ids) {
      var _this9 = this;

      var ret, mustBeQueried, result;
      return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default.a.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              ret = new Map();
              mustBeQueried = []; // first try to fill from docCache

              ids.forEach(function (id) {
                var doc = _this9._docCache.get(id);

                if (doc) {
                  ret.set(id, doc);
                } else {
                  mustBeQueried.push(id);
                }
              }); // find everything which was not in docCache

              if (!(mustBeQueried.length > 0)) {
                _context.next = 8;
                break;
              }

              _context.next = 6;
              return this.pouch.allDocs({
                include_docs: true,
                keys: mustBeQueried
              });

            case 6:
              result = _context.sent;
              result.rows.forEach(function (row) {
                if (!row.doc) {
                  // not found
                  return;
                }

                var plainData = _this9._handleFromPouch(row.doc);

                var doc = Object(_rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_22__[/* createRxDocument */ "a"])(_this9, plainData);
                ret.set(doc.primary, doc);
              });

            case 8:
              return _context.abrupt("return", ret);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function findByIds(_x) {
      return _findByIds.apply(this, arguments);
    }

    return findByIds;
  }()
  /**
   * like this.findByIds but returns an observable
   * that always emitts the current state
   */
  ;

  _proto.findByIds$ = function findByIds$(ids) {
    var _this10 = this;

    var currentValue = null;
    var initialPromise = this.findByIds(ids).then(function (docsMap) {
      currentValue = docsMap;
    });
    return this.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_4__[/* startWith */ "a"])(null), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__[/* mergeMap */ "b"])(function (ev) {
      return initialPromise.then(function () {
        return ev;
      });
    }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_6__[/* map */ "a"])(function (ev) {
      if (!currentValue) {
        throw new Error('should not happen');
      }

      if (!ev) {
        return currentValue;
      }

      if (!ids.includes(ev.documentId)) {
        return null;
      }

      var op = ev.operation;

      if (op === 'INSERT' || op === 'UPDATE') {
        currentValue.set(ev.documentId, _this10._docCache.get(ev.documentId));
      } else {
        currentValue["delete"](ev.documentId);
      }

      return currentValue;
    }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_3__[/* filter */ "a"])(function (x) {
      return !!x;
    }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_7__[/* shareReplay */ "a"])(1));
  }
  /**
   * Export collection to a JSON friendly format.
   * @param _decrypted
   * When true, all encrypted values will be decrypted.
   * When false or omitted and an interface or type is loaded in this collection,
   * all base properties of the type are typed as `any` since data could be encrypted.
   */
  ;

  _proto.dump = function dump() {
    var _decrypted = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('json-dump');
  }
  /**
   * Import the parsed JSON export into the collection.
   * @param _exportedJSON The previously exported data from the `<collection>.dump()` method.
   */
  ;

  _proto.importDump = function importDump(_exportedJSON) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('json-dump');
  }
  /**
   * waits for external changes to the database
   * and ensures they are emitted to the internal RxChangeEvent-Stream
   * TODO this can be removed by listening to the pull-change-events of the RxReplicationState
   */
  ;

  _proto.watchForChanges = function watchForChanges() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('watch-for-changes');
  }
  /**
   * sync with another database
   */
  ;

  _proto.sync = function sync(_syncOptions) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('replication');
  }
  /**
   * sync with a GraphQL endpoint
   */
  ;

  _proto.syncGraphQL = function syncGraphQL(options) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('replication-graphql');
  }
  /**
   * Create a replicated in-memory-collection
   */
  ;

  _proto.inMemory = function inMemory() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* pluginMissing */ "p"])('in-memory');
  }
  /**
   * HOOKS
   */
  ;

  _proto.addHook = function addHook(when, key, fun) {
    var parallel = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

    if (typeof fun !== 'function') {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxTypeError */ "c"])('COL7', {
        key: key,
        when: when
      });
    }

    if (!HOOKS_WHEN.includes(when)) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxTypeError */ "c"])('COL8', {
        key: key,
        when: when
      });
    }

    if (!HOOKS_KEYS.includes(key)) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL9', {
        key: key
      });
    }

    if (when === 'post' && key === 'create' && parallel === true) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL10', {
        when: when,
        key: key,
        parallel: parallel
      });
    } // bind this-scope to hook-function


    var boundFun = fun.bind(this);
    var runName = parallel ? 'parallel' : 'series';
    this.hooks[key] = this.hooks[key] || {};
    this.hooks[key][when] = this.hooks[key][when] || {
      series: [],
      parallel: []
    };
    this.hooks[key][when][runName].push(boundFun);
  };

  _proto.getHooks = function getHooks(when, key) {
    try {
      return this.hooks[key][when];
    } catch (e) {
      return {
        series: [],
        parallel: []
      };
    }
  };

  _proto._runHooks = function _runHooks(when, key, data, instance) {
    var hooks = this.getHooks(when, key);
    if (!hooks) return Promise.resolve(); // run parallel: false

    var tasks = hooks.series.map(function (hook) {
      return function () {
        return hook(data, instance);
      };
    });
    return Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* promiseSeries */ "q"])(tasks) // run parallel: true
    .then(function () {
      return Promise.all(hooks.parallel.map(function (hook) {
        return hook(data, instance);
      }));
    });
  }
  /**
   * does the same as ._runHooks() but with non-async-functions
   */
  ;

  _proto._runHooksSync = function _runHooksSync(when, key, data, instance) {
    var hooks = this.getHooks(when, key);
    if (!hooks) return;
    hooks.series.forEach(function (hook) {
      return hook(data, instance);
    });
  }
  /**
   * creates a temporaryDocument which can be saved later
   */
  ;

  _proto.newDocument = function newDocument() {
    var docData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    docData = this.schema.fillObjectWithDefaults(docData);
    var doc = Object(_rx_document__WEBPACK_IMPORTED_MODULE_21__[/* createWithConstructor */ "c"])(Object(_rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_22__[/* getRxDocumentConstructor */ "e"])(this), this, docData);
    doc._isTemporary = true;

    this._runHooksSync('post', 'create', docData, doc);

    return doc;
  };

  _proto.destroy = function destroy() {
    if (this.destroyed) return Promise.resolve(false);

    if (this._onDestroyCall) {
      this._onDestroyCall();
    }

    this._subs.forEach(function (sub) {
      return sub.unsubscribe();
    });

    if (this._changeEventBuffer) {
      this._changeEventBuffer.destroy();
    }

    this._repStates.forEach(function (sync) {
      return sync.cancel();
    });

    delete this.database.collections[this.name];
    this.destroyed = true;
    return Promise.resolve(true);
  }
  /**
   * remove all data of the collection
   */
  ;

  _proto.remove = function remove() {
    return this.database.removeCollection(this.name);
  };

  _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_2___default()(RxCollectionBase, [{
    key: "$",
    get: function get() {
      return this._observable$;
    }
  }, {
    key: "insert$",
    get: function get() {
      return this.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_3__[/* filter */ "a"])(function (cE) {
        return cE.operation === 'INSERT';
      }));
    }
  }, {
    key: "update$",
    get: function get() {
      return this.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_3__[/* filter */ "a"])(function (cE) {
        return cE.operation === 'UPDATE';
      }));
    }
  }, {
    key: "remove$",
    get: function get() {
      return this.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_3__[/* filter */ "a"])(function (cE) {
        return cE.operation === 'DELETE';
      }));
    }
  }, {
    key: "onDestroy",
    get: function get() {
      var _this11 = this;

      if (!this._onDestroy) {
        this._onDestroy = new Promise(function (res) {
          return _this11._onDestroyCall = res;
        });
      }

      return this._onDestroy;
    }
  }, {
    key: "asRxCollection",
    get: function get() {
      return this;
    }
  }]);

  return RxCollectionBase;
}();
/**
 * adds the hook-functions to the collections prototype
 * this runs only once
 */

function _applyHookFunctions(collection) {
  if (hooksApplied) return; // already run

  hooksApplied = true;
  var colProto = Object.getPrototypeOf(collection);
  HOOKS_KEYS.forEach(function (key) {
    HOOKS_WHEN.map(function (when) {
      var fnName = when + Object(_util__WEBPACK_IMPORTED_MODULE_8__[/* ucfirst */ "B"])(key);

      colProto[fnName] = function (fun, parallel) {
        return this.addHook(when, key, fun, parallel);
      };
    });
  });
}

function _atomicUpsertUpdate(doc, json) {
  return doc.atomicUpdate(function (innerDoc) {
    json._rev = innerDoc._rev;
    innerDoc._data = json;
    return innerDoc._data;
  }).then(function () {
    return doc;
  });
}
/**
 * ensures that the given document exists
 * @return promise that resolves with new doc and flag if inserted
 */


function _atomicUpsertEnsureRxDocumentExists(rxCollection, primary, json) {
  return rxCollection.findOne(primary).exec().then(function (doc) {
    if (!doc) {
      return rxCollection.insert(json).then(function (newDoc) {
        return {
          doc: newDoc,
          inserted: true
        };
      });
    } else {
      return {
        doc: doc,
        inserted: false
      };
    }
  });
}
/**
 * creates the indexes in the pouchdb
 */


function _prepareCreateIndexes(rxCollection, spawnedPouchPromise) {
  /**
   * pouchdb does no check on already existing indexes
   * which makes collection re-creation really slow on page reloads
   * So we have to manually check if the index already exists
   */
  return spawnedPouchPromise.then(function () {
    return rxCollection.pouch.getIndexes();
  }).then(function (indexResult) {
    var existingIndexes = new Set();
    indexResult.indexes.forEach(function (idx) {
      return existingIndexes.add(idx.name);
    });
    return existingIndexes;
  }).then(function (existingIndexes) {
    return Promise.all(rxCollection.schema.indexes.map(function (indexAr) {
      var compressedIdx = indexAr.map(function (key) {
        var primPath = rxCollection.schema.primaryPath;
        var useKey = key === primPath ? '_id' : key;

        if (!rxCollection.schema.doKeyCompression()) {
          return useKey;
        } else {
          var indexKey = rxCollection._keyCompressor.transformKey(useKey);

          return indexKey;
        }
      });
      var indexName = 'idx-rxdb-index-' + compressedIdx.join(',');

      if (existingIndexes.has(indexName)) {
        // index already exists
        return;
      }
      /**
       * TODO
       * we might have even better performance by doing a bulkDocs
       * on index creation
       */


      return spawnedPouchPromise.then(function () {
        return rxCollection.pouch.createIndex({
          name: indexName,
          ddoc: indexName,
          index: {
            fields: compressedIdx
          }
        });
      });
    }));
  });
}
/**
 * creates and prepares a new collection
 */


function create(_ref2, wasCreatedBefore) {
  var database = _ref2.database,
      name = _ref2.name,
      schema = _ref2.schema,
      _ref2$pouchSettings = _ref2.pouchSettings,
      pouchSettings = _ref2$pouchSettings === void 0 ? {} : _ref2$pouchSettings,
      _ref2$migrationStrate = _ref2.migrationStrategies,
      migrationStrategies = _ref2$migrationStrate === void 0 ? {} : _ref2$migrationStrate,
      _ref2$autoMigrate = _ref2.autoMigrate,
      autoMigrate = _ref2$autoMigrate === void 0 ? true : _ref2$autoMigrate,
      _ref2$statics = _ref2.statics,
      statics = _ref2$statics === void 0 ? {} : _ref2$statics,
      _ref2$methods = _ref2.methods,
      methods = _ref2$methods === void 0 ? {} : _ref2$methods,
      _ref2$attachments = _ref2.attachments,
      attachments = _ref2$attachments === void 0 ? {} : _ref2$attachments,
      _ref2$options = _ref2.options,
      options = _ref2$options === void 0 ? {} : _ref2$options,
      _ref2$cacheReplacemen = _ref2.cacheReplacementPolicy,
      cacheReplacementPolicy = _ref2$cacheReplacemen === void 0 ? _query_cache__WEBPACK_IMPORTED_MODULE_17__[/* defaultCacheReplacementPolicy */ "i"] : _ref2$cacheReplacemen;
  Object(_pouch_db__WEBPACK_IMPORTED_MODULE_9__[/* validateCouchDBString */ "h"])(name); // ensure it is a schema-object

  if (!Object(_rx_schema__WEBPACK_IMPORTED_MODULE_12__[/* isInstanceOf */ "g"])(schema)) {
    schema = Object(_rx_schema__WEBPACK_IMPORTED_MODULE_12__[/* createRxSchema */ "b"])(schema);
  }

  Object.keys(methods).filter(function (funName) {
    return schema.topLevelFields.includes(funName);
  }).forEach(function (funName) {
    throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_14__[/* newRxError */ "b"])('COL18', {
      funName: funName
    });
  });
  var collection = new RxCollectionBase(database, name, schema, pouchSettings, migrationStrategies, methods, attachments, options, cacheReplacementPolicy, statics);
  return collection.prepare(wasCreatedBefore).then(function () {
    // ORM add statics
    Object.entries(statics).forEach(function (_ref3) {
      var funName = _ref3[0],
          fun = _ref3[1];
      Object.defineProperty(collection, funName, {
        get: function get() {
          return fun.bind(collection);
        }
      });
    });
    var ret = Promise.resolve();

    if (autoMigrate && collection.schema.version !== 0) {
      ret = collection.migratePromise();
    }

    return ret;
  }).then(function () {
    Object(_hooks__WEBPACK_IMPORTED_MODULE_20__[/* runPluginHooks */ "d"])('createRxCollection', collection);
    return collection;
  });
}
function isInstanceOf(obj) {
  return obj instanceof RxCollectionBase;
}
/* unused harmony default export */ var _unused_webpack_default_export = ({
  create: create,
  isInstanceOf: isInstanceOf,
  RxCollectionBase: RxCollectionBase
});
//# sourceMappingURL=rx-collection.js.map

/***/ }),

/***/ "1513":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ rx_database_RxDatabaseBase; });
__webpack_require__.d(__webpack_exports__, "b", function() { return /* binding */ _collectionNamePrimary; });
__webpack_require__.d(__webpack_exports__, "d", function() { return /* binding */ createRxDatabase; });
__webpack_require__.d(__webpack_exports__, "g", function() { return /* binding */ removeRxDatabase; });
__webpack_require__.d(__webpack_exports__, "c", function() { return /* binding */ checkAdapter; });
__webpack_require__.d(__webpack_exports__, "f", function() { return /* binding */ isInstanceOf; });
__webpack_require__.d(__webpack_exports__, "e", function() { return /* binding */ dbCount; });

// UNUSED EXPORTS: _ensureStorageTokenExists, writeToSocket, _removeAllOfCollection

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/@babel/runtime/regenerator/index.js
var regenerator = __webpack_require__("56d4");
var regenerator_default = /*#__PURE__*/__webpack_require__.n(regenerator);

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/@babel/runtime/helpers/asyncToGenerator.js
var asyncToGenerator = __webpack_require__("71b8");
var asyncToGenerator_default = /*#__PURE__*/__webpack_require__.n(asyncToGenerator);

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/@babel/runtime/helpers/createClass.js
var createClass = __webpack_require__("63d2");
var createClass_default = /*#__PURE__*/__webpack_require__.n(createClass);

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/random-token/index.js
var random_token = __webpack_require__("f1a6");
var random_token_default = /*#__PURE__*/__webpack_require__.n(random_token);

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/custom-idle-queue/dist/es/index.js
var es = __webpack_require__("05b4");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/broadcast-channel/dist/es/broadcast-channel.js + 7 modules
var broadcast_channel = __webpack_require__("c247");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/util.js
var util = __webpack_require__("02aa");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-error.js
var rx_error = __webpack_require__("7733");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-schema.js
var rx_schema = __webpack_require__("ab32");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-change-event.js
var rx_change_event = __webpack_require__("c9cd");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/overwritable.js
var overwritable = __webpack_require__("e73d");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/hooks.js
var hooks = __webpack_require__("ac6e");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxjs/_esm5/internal/Subject.js
var Subject = __webpack_require__("7d02");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxjs/_esm5/internal/operators/filter.js
var filter = __webpack_require__("cf9c");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/pouch-db.js
var pouch_db = __webpack_require__("d79b");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-collection.js
var rx_collection = __webpack_require__("11ea");

// EXTERNAL MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-storage-pouchdb.js
var rx_storage_pouchdb = __webpack_require__("723f");

// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-database-internal-store.js
/**
 * In this file we handle all accesses to the internal store of the database
 * This store is used to save hashes and checksums and metadata
 * ATM this only works with PouchDB but in the future
 * it should work by using the storage.interface
 */

// will be typed when we have more then one
var INTERNAL_STORAGE_NAME = '_rxdb_internal';
/**
 * returns to local document with the given id
 * or null if not exists
 */

function getLocalDocument(storageInstance, id) {
  return storageInstance.get(util["a" /* LOCAL_PREFIX */] + id)["catch"](function () {
    return null;
  });
}
function setLocalDocument(storageInstance, id, value) {
  return storageInstance.put({
    _id: id,
    value: value
  }).then(function () {});
}
function putDocument(storageInstance, doc) {
  return storageInstance.put(doc).then(function (putResult) {
    return Object.assign({
      _id: putResult.id,
      _rev: putResult.rev
    }, doc);
  });
}
/**
 * returns all NON-LOCAL documents
 */

function getAllDocuments(storageInstance) {
  return storageInstance.allDocs({
    include_docs: true
  }).then(function (result) {
    return result.rows;
  });
}
/**
 * deletes the storage instance and all of it's data
 */

function deleteStorageInstance(storageInstance) {
  return storageInstance.destroy();
}
//# sourceMappingURL=rx-database-internal-store.js.map
// CONCATENATED MODULE: /Users/pilou/dev/platyplus/platydev/node_modules/rxdb/dist/es/rx-database.js



















/**
 * stores the combinations
 * of used database-names with their adapters
 * so we can throw when the same database is created more then once
 */

var USED_COMBINATIONS = {};
var DB_COUNT = 0;
var rx_database_RxDatabaseBase = /*#__PURE__*/function () {
  function RxDatabaseBase(name, adapter, password, multiInstance) {
    var eventReduce = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
    var options = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    var pouchSettings = arguments.length > 6 ? arguments[6] : undefined;
    this.internalStore = {};
    this.idleQueue = new es["a" /* IdleQueue */]();
    this.token = random_token_default()(10);
    this._subs = [];
    this.destroyed = false;
    this.subject = new Subject["a" /* Subject */]();
    this.observable$ = this.subject.asObservable().pipe(Object(filter["a" /* filter */])(function (cEvent) {
      return Object(rx_change_event["f" /* isInstanceOf */])(cEvent);
    }));
    this.name = name;
    this.adapter = adapter;
    this.password = password;
    this.multiInstance = multiInstance;
    this.eventReduce = eventReduce;
    this.options = options;
    this.pouchSettings = pouchSettings;
    this.storage = Object(rx_storage_pouchdb["b" /* getRxStoragePouchDb */])(adapter, pouchSettings);
    this.collections = {};
    DB_COUNT++;
  }

  var _proto = RxDatabaseBase.prototype;

  /**
   * removes all internal collection-info
   * only use this if you have to upgrade from a major rxdb-version
   * do NEVER use this to change the schema of a collection
   */
  _proto.dangerousRemoveCollectionInfo = function dangerousRemoveCollectionInfo() {
    var _this = this;

    return getAllDocuments(this.internalStore).then(function (docsRes) {
      return Promise.all(docsRes.map(function (row) {
        return {
          _id: row.key,
          _rev: row.value.rev
        };
      }).map(function (doc) {
        return _this.internalStore.remove(doc._id, doc._rev);
      }));
    });
  }
  /**
   * spawns a new pouch-instance
   */
  ;

  _proto._spawnPouchDB = function _spawnPouchDB(collectionName, schemaVersion) {
    var pouchSettings = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return this.storage.createStorageInstance(this.name, collectionName, schemaVersion, {
      pouchSettings: pouchSettings
    });
  }
  /**
   * This is the main handle-point for all change events
   * ChangeEvents created by this instance go:
   * RxDocument -> RxCollection -> RxDatabase.$emit -> MultiInstance
   * ChangeEvents created by other instances go:
   * MultiInstance -> RxDatabase.$emit -> RxCollection -> RxDatabase
   */
  ;

  _proto.$emit = function $emit(changeEvent) {
    if (!changeEvent) return; // emit into own stream

    this.subject.next(changeEvent); // write to socket if event was created by this instance

    if (changeEvent.databaseToken === this.token) {
      writeToSocket(this, changeEvent);
    }
  }
  /**
   * removes the collection-doc from this._collectionsPouch
   */
  ;

  _proto.removeCollectionDoc = function removeCollectionDoc(name, schema) {
    var _this2 = this;

    var docId = _collectionNamePrimary(name, schema);

    return this.internalStore.get(docId).then(function (doc) {
      return _this2.lockedRun(function () {
        return _this2.internalStore.remove(doc);
      });
    });
  }
  /**
   * creates multiple RxCollections at once
   * to be much faster by saving db txs and doing stuff in bulk-operations
   * This function is not called often, but mostly in the critical path at the initial page load
   * So it must be as fast as possible
   */
  ;

  _proto.addCollections =
  /*#__PURE__*/
  function () {
    var _addCollections = asyncToGenerator_default()( /*#__PURE__*/regenerator_default.a.mark(function _callee(collectionCreators) {
      var _this3 = this;

      var pouch, result, internalDocByCollectionName, schemaHashByName, collections, bulkPutDocs, ret;
      return regenerator_default.a.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              pouch = this.internalStore; // get local management docs in bulk request

              _context.next = 3;
              return pouch.allDocs({
                include_docs: true,
                keys: Object.keys(collectionCreators).map(function (name) {
                  return _collectionNamePrimary(name, collectionCreators[name].schema);
                })
              });

            case 3:
              result = _context.sent;
              internalDocByCollectionName = {};
              result.rows.forEach(function (row) {
                if (!row.error) {
                  internalDocByCollectionName[row.key] = row.doc;
                }
              });
              schemaHashByName = {};
              _context.next = 9;
              return Promise.all(Object.entries(collectionCreators).map(function (_ref) {
                var name = _ref[0],
                    args = _ref[1];

                var internalDoc = internalDocByCollectionName[_collectionNamePrimary(name, collectionCreators[name].schema)];

                var useArgs = Object(util["f" /* flatClone */])(args);
                useArgs.name = name;
                var schema = Object(rx_schema["b" /* createRxSchema */])(args.schema);
                schemaHashByName[name] = schema.hash;
                useArgs.schema = schema;
                useArgs.database = _this3; // TODO check if already exists and schema hash has changed
                // collection already exists

                if (_this3.collections[name]) {
                  throw Object(rx_error["b" /* newRxError */])('DB3', {
                    name: name
                  });
                } // collection already exists but has different schema


                if (internalDoc && internalDoc.schemaHash !== schemaHashByName[name]) {
                  throw Object(rx_error["b" /* newRxError */])('DB6', {
                    name: name,
                    previousSchemaHash: internalDoc.schemaHash,
                    schemaHash: schemaHashByName[name]
                  });
                } // run hooks


                var hookData = Object(util["f" /* flatClone */])(args);
                hookData.database = _this3;
                hookData.name = name;
                Object(hooks["d" /* runPluginHooks */])('preCreateRxCollection', hookData);
                return Object(rx_collection["b" /* create */])(useArgs, !!internalDoc);
              }));

            case 9:
              collections = _context.sent;
              bulkPutDocs = [];
              ret = {};
              collections.forEach(function (collection) {
                var name = collection.name;
                ret[name] = collection;

                if (collection.schema.crypt && !_this3.password) {
                  throw Object(rx_error["b" /* newRxError */])('DB7', {
                    name: name
                  });
                } // add to bulk-docs list


                if (!internalDocByCollectionName[name]) {
                  bulkPutDocs.push({
                    _id: _collectionNamePrimary(name, collectionCreators[name].schema),
                    schemaHash: schemaHashByName[name],
                    schema: collection.schema.normalized,
                    version: collection.schema.version
                  });
                } // set as getter to the database


                _this3.collections[name] = collection;

                if (!_this3[name]) {
                  Object.defineProperty(_this3, name, {
                    get: function get() {
                      return _this3.collections[name];
                    }
                  });
                }
              }); // make a single call to the pouchdb instance

              if (!(bulkPutDocs.length > 0)) {
                _context.next = 16;
                break;
              }

              _context.next = 16;
              return pouch.bulkDocs({
                docs: bulkPutDocs
              });

            case 16:
              return _context.abrupt("return", ret);

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function addCollections(_x) {
      return _addCollections.apply(this, arguments);
    }

    return addCollections;
  }()
  /**
   * create or fetch a collection
   * @deprecated use addCollections() instead, it is faster and better typed
   */
  ;

  _proto.collection = function collection(args) {
    var _this$addCollections;

    if (typeof args === 'string') {
      return Promise.resolve(this.collections[args]);
    } // collection() is deprecated, call new bulk-creation method


    return this.addCollections((_this$addCollections = {}, _this$addCollections[args.name] = args, _this$addCollections)).then(function (colObject) {
      return colObject[args.name];
    });
  }
  /**
   * delete all data of the collection and its previous versions
   */
  ;

  _proto.removeCollection = function removeCollection(collectionName) {
    var _this4 = this;

    if (this.collections[collectionName]) this.collections[collectionName].destroy(); // remove schemas from internal db

    return _removeAllOfCollection(this, collectionName) // get all relevant pouchdb-instances
    .then(function (knownVersions) {
      return knownVersions.map(function (v) {
        return _this4._spawnPouchDB(collectionName, v);
      });
    }) // remove documents
    .then(function (pouches) {
      return Promise.all(pouches.map(function (pouch) {
        return _this4.lockedRun(function () {
          return pouch.destroy();
        });
      }));
    }).then(function () {});
  }
  /**
   * runs the given function between idleQueue-locking
   */
  ;

  _proto.lockedRun = function lockedRun(fn) {
    return this.idleQueue.wrapCall(fn);
  };

  _proto.requestIdlePromise = function requestIdlePromise() {
    return this.idleQueue.requestIdlePromise();
  }
  /**
   * Export database to a JSON friendly format.
   * @param _decrypted
   * When true, all encrypted values will be decrypted.
   */
  ;

  _proto.dump = function dump() {
    var _decrypted = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    var _collections = arguments.length > 1 ? arguments[1] : undefined;

    throw Object(util["p" /* pluginMissing */])('json-dump');
  }
  /**
   * Import the parsed JSON export into the collection.
   * @param _exportedJSON The previously exported data from the `<db>.dump()` method.
   * @note When an interface is loaded in this collection all base properties of the type are typed as `any`
   * since data could be encrypted.
   */
  ;

  _proto.importDump = function importDump(_exportedJSON) {
    throw Object(util["p" /* pluginMissing */])('json-dump');
  }
  /**
   * spawn server
   */
  ;

  _proto.server = function server(_options) {
    throw Object(util["p" /* pluginMissing */])('server');
  };

  _proto.leaderElector = function leaderElector() {
    throw Object(util["p" /* pluginMissing */])('leader-election');
  };

  _proto.isLeader = function isLeader() {
    throw Object(util["p" /* pluginMissing */])('leader-election');
  }
  /**
   * returns a promise which resolves when the instance becomes leader
   */
  ;

  _proto.waitForLeadership = function waitForLeadership() {
    throw Object(util["p" /* pluginMissing */])('leader-election');
  }
  /**
   * destroys the database-instance and all collections
   */
  ;

  _proto.destroy = function destroy() {
    var _this5 = this;

    if (this.destroyed) return Promise.resolve(false);
    Object(hooks["d" /* runPluginHooks */])('preDestroyRxDatabase', this);
    DB_COUNT--;
    this.destroyed = true;

    if (this.broadcastChannel) {
      /**
       * The broadcast-channel gets closed lazy
       * to ensure that all pending change-events
       * get emitted
       */
      setTimeout(function () {
        return _this5.broadcastChannel.close();
      }, 1000);
    }

    this._subs.map(function (sub) {
      return sub.unsubscribe();
    }); // destroy all collections


    return Promise.all(Object.keys(this.collections).map(function (key) {
      return _this5.collections[key];
    }).map(function (col) {
      return col.destroy();
    })) // remove combination from USED_COMBINATIONS-map
    .then(function () {
      return _removeUsedCombination(_this5.name, _this5.adapter);
    }).then(function () {
      return true;
    });
  }
  /**
   * deletes the database and its stored data
   */
  ;

  _proto.remove = function remove() {
    var _this6 = this;

    return this.destroy().then(function () {
      return removeRxDatabase(_this6.name, _this6.adapter);
    });
  };

  createClass_default()(RxDatabaseBase, [{
    key: "$",
    get: function get() {
      return this.observable$;
    }
  }]);

  return RxDatabaseBase;
}();
/**
 * checks if an instance with same name and adapter already exists
 * @throws {RxError} if used
 */

function _isNameAdapterUsed(name, adapter) {
  if (!USED_COMBINATIONS[name]) return false;
  var used = false;
  USED_COMBINATIONS[name].forEach(function (ad) {
    if (ad === adapter) used = true;
  });

  if (used) {
    throw Object(rx_error["b" /* newRxError */])('DB8', {
      name: name,
      adapter: adapter,
      link: 'https://pubkey.github.io/rxdb/rx-database.html#ignoreduplicate'
    });
  }
}

function _removeUsedCombination(name, adapter) {
  if (!USED_COMBINATIONS[name]) return;
  var index = USED_COMBINATIONS[name].indexOf(adapter);
  USED_COMBINATIONS[name].splice(index, 1);
}
/**
 * to not confuse multiInstance-messages with other databases that have the same
 * name and adapter, but do not share state with this one (for example in-memory-instances),
 * we set a storage-token and use it in the broadcast-channel
 */


function _ensureStorageTokenExists(rxDatabase) {
  return rxDatabase.internalStore.get(util["a" /* LOCAL_PREFIX */] + 'storageToken')["catch"](function () {
    // no doc exists -> insert
    return rxDatabase.internalStore.put({
      _id: util["a" /* LOCAL_PREFIX */] + 'storageToken',
      value: random_token_default()(10)
    })["catch"](function () {}).then(function () {
      return Object(util["r" /* promiseWait */])(0);
    });
  }).then(function () {
    return rxDatabase.internalStore.get(util["a" /* LOCAL_PREFIX */] + 'storageToken');
  }).then(function (storageTokenDoc2) {
    return storageTokenDoc2.value;
  });
}
/**
 * writes the changeEvent to the broadcastChannel
 */

function writeToSocket(rxDatabase, changeEvent) {
  if (rxDatabase.multiInstance && !changeEvent.isIntern() && rxDatabase.broadcastChannel) {
    var sendOverChannel = {
      cE: changeEvent.toJSON(),
      storageToken: rxDatabase.storageToken
    };
    return rxDatabase.broadcastChannel.postMessage(sendOverChannel).then(function () {
      return true;
    });
  } else return Promise.resolve(false);
}
/**
 * returns the primary for a given collection-data
 * used in the internal pouchdb-instances
 */

function _collectionNamePrimary(name, schema) {
  return name + '-' + schema.version;
}
/**
 * removes all internal docs of a given collection
 * @return resolves all known collection-versions
 */

function _removeAllOfCollection(rxDatabase, collectionName) {
  return rxDatabase.lockedRun(function () {
    return getAllDocuments(rxDatabase.internalStore);
  }).then(function (data) {
    var relevantDocs = data.map(function (row) {
      return row.doc;
    }).filter(function (doc) {
      var name = doc._id.split('-')[0];

      return name === collectionName;
    });
    return Promise.all(relevantDocs.map(function (doc) {
      return rxDatabase.lockedRun(function () {
        return rxDatabase.internalStore.remove(doc);
      });
    })).then(function () {
      return relevantDocs.map(function (doc) {
        return doc.version;
      });
    });
  });
}

function _prepareBroadcastChannel(rxDatabase) {
  // broadcastChannel
  rxDatabase.broadcastChannel = new broadcast_channel["a" /* BroadcastChannel */]('RxDB:' + rxDatabase.name + ':' + 'socket');
  rxDatabase.broadcastChannel$ = new Subject["a" /* Subject */]();

  rxDatabase.broadcastChannel.onmessage = function (msg) {
    if (msg.storageToken !== rxDatabase.storageToken) return; // not same storage-state

    if (msg.cE.databaseToken === rxDatabase.token) return; // same db

    var changeEvent = new rx_change_event["a" /* RxChangeEvent */](msg.cE.operation, msg.cE.documentId, msg.cE.documentData, msg.cE.databaseToken, msg.cE.collectionName, msg.cE.isLocal, msg.cE.startTime, msg.cE.endTime, msg.cE.previousData);
    rxDatabase.broadcastChannel$.next(changeEvent);
  }; // TODO only subscribe when something is listening to the event-chain


  rxDatabase._subs.push(rxDatabase.broadcastChannel$.subscribe(function (cE) {
    rxDatabase.$emit(cE);
  }));
}
/**
 * do the async things for this database
 */


function prepare(rxDatabase) {
  return rxDatabase.storage.createInternalStorageInstance(rxDatabase.name).then(function (internalStore) {
    rxDatabase.internalStore = internalStore;
    return _ensureStorageTokenExists(rxDatabase);
  }).then(function (storageToken) {
    rxDatabase.storageToken = storageToken;

    if (rxDatabase.multiInstance) {
      _prepareBroadcastChannel(rxDatabase);
    }
  });
}

function createRxDatabase(_ref2) {
  var name = _ref2.name,
      adapter = _ref2.adapter,
      password = _ref2.password,
      _ref2$multiInstance = _ref2.multiInstance,
      multiInstance = _ref2$multiInstance === void 0 ? true : _ref2$multiInstance,
      _ref2$eventReduce = _ref2.eventReduce,
      eventReduce = _ref2$eventReduce === void 0 ? false : _ref2$eventReduce,
      _ref2$ignoreDuplicate = _ref2.ignoreDuplicate,
      ignoreDuplicate = _ref2$ignoreDuplicate === void 0 ? false : _ref2$ignoreDuplicate,
      _ref2$options = _ref2.options,
      options = _ref2$options === void 0 ? {} : _ref2$options,
      _ref2$pouchSettings = _ref2.pouchSettings,
      pouchSettings = _ref2$pouchSettings === void 0 ? {} : _ref2$pouchSettings;
  Object(hooks["d" /* runPluginHooks */])('preCreateRxDatabase', {
    name: name,
    adapter: adapter,
    password: password,
    multiInstance: multiInstance,
    eventReduce: eventReduce,
    ignoreDuplicate: ignoreDuplicate,
    options: options,
    pouchSettings: pouchSettings
  }); // check if pouchdb-adapter

  if (typeof adapter === 'string') {
    // TODO make a function hasAdapter()
    if (!pouch_db["a" /* PouchDB */].adapters || !pouch_db["a" /* PouchDB */].adapters[adapter]) {
      throw Object(rx_error["b" /* newRxError */])('DB9', {
        adapter: adapter
      });
    }
  } else {
    Object(pouch_db["e" /* isLevelDown */])(adapter);

    if (!pouch_db["a" /* PouchDB */].adapters || !pouch_db["a" /* PouchDB */].adapters.leveldb) {
      throw Object(rx_error["b" /* newRxError */])('DB10', {
        adapter: adapter
      });
    }
  }

  if (password) {
    overwritable["a" /* overwritable */].validatePassword(password);
  } // check if combination already used


  if (!ignoreDuplicate) {
    _isNameAdapterUsed(name, adapter);
  } // add to used_map


  if (!USED_COMBINATIONS[name]) {
    USED_COMBINATIONS[name] = [];
  }

  USED_COMBINATIONS[name].push(adapter);
  var rxDatabase = new rx_database_RxDatabaseBase(name, adapter, password, multiInstance, eventReduce, options, pouchSettings);
  return prepare(rxDatabase).then(function () {
    return Object(hooks["c" /* runAsyncPluginHooks */])('createRxDatabase', rxDatabase);
  }).then(function () {
    return rxDatabase;
  });
}
/**
 * removes the database and all its known data
 */

function removeRxDatabase(databaseName, adapter) {
  var storage = Object(rx_storage_pouchdb["b" /* getRxStoragePouchDb */])(adapter);
  return storage.createInternalStorageInstance(databaseName).then(function (internalStore) {
    return getAllDocuments(internalStore).then(function (docs) {
      // remove collections storages
      return Promise.all(docs.map(function (colDoc) {
        return colDoc.id;
      }).map(function (id) {
        var split = id.split('-');
        var name = split[0];
        var version = parseInt(split[1], 10);
        var instance = storage.createStorageInstance(databaseName, name, version);
        return instance.destroy();
      }));
    }) // remove internals
    .then(function () {
      return deleteStorageInstance(internalStore);
    });
  });
}
/**
 * check if the given adapter can be used
 */

function checkAdapter(adapter) {
  return overwritable["a" /* overwritable */].checkAdapter(adapter);
}
function isInstanceOf(obj) {
  return obj instanceof rx_database_RxDatabaseBase;
}
function dbCount() {
  return DB_COUNT;
}
/* harmony default export */ var rx_database = ({
  createRxDatabase: createRxDatabase,
  removeRxDatabase: removeRxDatabase,
  checkAdapter: checkAdapter,
  isInstanceOf: isInstanceOf,
  RxDatabaseBase: rx_database_RxDatabaseBase,
  dbCount: dbCount
});
//# sourceMappingURL=rx-database.js.map

/***/ }),

/***/ "2a87":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return getDocumentPrototype; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return getRxDocumentConstructor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return createRxDocument; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return createRxDocuments; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return getDocumentOrmPrototype; });
/* harmony import */ var _rx_document__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("6c14");
/* harmony import */ var _hooks__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("ac6e");
/**
 * For the ORM capabilities,
 * we have to merge the document prototype
 * with the ORM functions and the data
 * We do this itterating over the properties and
 * adding them to a new object.
 * In the future we should do this by chaining the __proto__ objects
 */

 // caches

var protoForCollection = new WeakMap();
var constructorForCollection = new WeakMap();
function getDocumentPrototype(rxCollection) {
  if (!protoForCollection.has(rxCollection)) {
    var schemaProto = rxCollection.schema.getDocumentPrototype();
    var ormProto = getDocumentOrmPrototype(rxCollection);
    var baseProto = _rx_document__WEBPACK_IMPORTED_MODULE_0__[/* basePrototype */ "a"];
    var proto = {};
    [schemaProto, ormProto, baseProto].forEach(function (obj) {
      var props = Object.getOwnPropertyNames(obj);
      props.forEach(function (key) {
        var desc = Object.getOwnPropertyDescriptor(obj, key);
        /**
         * When enumerable is true, it will show on console.dir(instance)
         * To not polute the output, only getters and methods are enumerable
         */

        var enumerable = true;
        if (key.startsWith('_') || key.endsWith('_') || key.startsWith('$') || key.endsWith('$')) enumerable = false;

        if (typeof desc.value === 'function') {
          // when getting a function, we automatically do a .bind(this)
          Object.defineProperty(proto, key, {
            get: function get() {
              return desc.value.bind(this);
            },
            enumerable: enumerable,
            configurable: false
          });
        } else {
          desc.enumerable = enumerable;
          desc.configurable = false;
          if (desc.writable) desc.writable = false;
          Object.defineProperty(proto, key, desc);
        }
      });
    });
    protoForCollection.set(rxCollection, proto);
  }

  return protoForCollection.get(rxCollection);
}
function getRxDocumentConstructor(rxCollection) {
  if (!constructorForCollection.has(rxCollection)) {
    var ret = Object(_rx_document__WEBPACK_IMPORTED_MODULE_0__[/* createRxDocumentConstructor */ "b"])(getDocumentPrototype(rxCollection));
    constructorForCollection.set(rxCollection, ret);
  }

  return constructorForCollection.get(rxCollection);
}
/**
 * create a RxDocument-instance from the jsonData
 * and the prototype merge
 */

function createRxDocument(rxCollection, docData) {
  // return from cache if exsists
  var id = docData[rxCollection.schema.primaryPath];

  var cacheDoc = rxCollection._docCache.get(id);

  if (cacheDoc) return cacheDoc;
  var doc = Object(_rx_document__WEBPACK_IMPORTED_MODULE_0__[/* createWithConstructor */ "c"])(getRxDocumentConstructor(rxCollection), rxCollection, docData);

  rxCollection._docCache.set(id, doc);

  rxCollection._runHooksSync('post', 'create', docData, doc);

  Object(_hooks__WEBPACK_IMPORTED_MODULE_1__[/* runPluginHooks */ "d"])('postCreateRxDocument', doc);
  return doc;
}
/**
 * create RxDocument from the docs-array
 */

function createRxDocuments(rxCollection, docsJSON) {
  return docsJSON.map(function (json) {
    return createRxDocument(rxCollection, json);
  });
}
/**
 * returns the prototype-object
 * that contains the orm-methods,
 * used in the proto-merge
 */

function getDocumentOrmPrototype(rxCollection) {
  var proto = {};
  Object.entries(rxCollection.methods).forEach(function (_ref) {
    var k = _ref[0],
        v = _ref[1];
    proto[k] = v;
  });
  return proto;
}
//# sourceMappingURL=rx-document-prototype-merge.js.map

/***/ }),

/***/ "352c":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return _handleToPouch; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return _handleFromPouch; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return fillObjectDataBeforeInsert; });
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("02aa");
/* harmony import */ var _rx_error__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("7733");


/**
 * wrappers for Pouch.put/get to handle keycompression etc
 */

function _handleToPouch(col, data) {
  data = col._crypter.encrypt(data);
  data = col.schema.swapPrimaryToId(data);
  if (col.schema.doKeyCompression()) data = col._keyCompressor.compress(data);
  return data;
}
function _handleFromPouch(col, data) {
  var noDecrypt = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  data = col.schema.swapIdToPrimary(data);
  if (col.schema.doKeyCompression()) data = col._keyCompressor.decompress(data);
  if (noDecrypt) return data;
  data = col._crypter.decrypt(data);
  return data;
}
/**
 * fills in the _id and the
 * default data.
 * This also clones the data
 */

function fillObjectDataBeforeInsert(collection, data) {
  var useJson = collection.schema.fillObjectWithDefaults(data);

  if (useJson._id && collection.schema.primaryPath !== '_id') {
    throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_1__[/* newRxError */ "b"])('COL2', {
      data: data
    });
  } // fill _id


  if (collection.schema.primaryPath === '_id' && !useJson._id) {
    useJson._id = Object(_util__WEBPACK_IMPORTED_MODULE_0__[/* generateId */ "h"])();
  }

  return useJson;
}
//# sourceMappingURL=rx-collection-helper.js.map

/***/ }),

/***/ "4877":
/***/ (function(module, exports) {


//# sourceMappingURL=mocha.parallel.d.js.map

/***/ }),

/***/ "4eec":
/***/ (function(module, exports) {


//# sourceMappingURL=modifiyjs.d.js.map

/***/ }),

/***/ "6c14":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return basePrototype; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return createRxDocumentConstructor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return defineGetterSetter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return createWithConstructor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return isInstanceOf; });
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("56d4");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("71b8");
/* harmony import */ var _babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var object_path__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("3f90");
/* harmony import */ var object_path__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(object_path__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("2e21");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("260e");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("96ab");
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("02aa");
/* harmony import */ var _rx_change_event__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("c9cd");
/* harmony import */ var _rx_error__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("7733");
/* harmony import */ var _hooks__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("ac6e");









var basePrototype = {
  /**
   * TODO
   * instead of appliying the _this-hack
   * we should make these accesors functions instead of getters.
   */
  get _data() {
    var _this = this;
    /**
     * Might be undefined when vuejs-devtools are used
     * @link https://github.com/pubkey/rxdb/issues/1126
     */


    if (!_this.isInstanceOfRxDocument) {
      return undefined;
    }

    return _this._dataSync$.getValue();
  },

  get primaryPath() {
    var _this = this;

    if (!_this.isInstanceOfRxDocument) {
      return undefined;
    }

    return _this.collection.schema.primaryPath;
  },

  get primary() {
    var _this = this;

    if (!_this.isInstanceOfRxDocument) {
      return undefined;
    }

    return _this._data[_this.primaryPath];
  },

  get revision() {
    var _this = this;

    if (!_this.isInstanceOfRxDocument) {
      return undefined;
    }

    return _this._data._rev;
  },

  get deleted$() {
    var _this = this;

    if (!_this.isInstanceOfRxDocument) {
      return undefined;
    }

    return _this._deleted$.asObservable();
  },

  get deleted() {
    var _this = this;

    if (!_this.isInstanceOfRxDocument) {
      return undefined;
    }

    return _this._deleted$.getValue();
  },

  /**
   * returns the observable which emits the plain-data of this document
   */
  get $() {
    var _this = this;

    return _this._dataSync$.asObservable();
  },

  _handleChangeEvent: function _handleChangeEvent(changeEvent) {
    if (changeEvent.documentId !== this.primary) return; // ensure that new _rev is higher then current

    var newRevNr = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* getHeightOfRevision */ "i"])(changeEvent.documentData._rev);
    var currentRevNr = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* getHeightOfRevision */ "i"])(this._data._rev);
    if (currentRevNr > newRevNr) return;

    switch (changeEvent.operation) {
      case 'INSERT':
        break;

      case 'UPDATE':
        var newData = changeEvent.documentData;

        this._dataSync$.next(newData);

        break;

      case 'DELETE':
        // remove from docCache to assure new upserted RxDocuments will be a new instance
        this.collection._docCache["delete"](this.primary);

        this._deleted$.next(true);

        break;
    }
  },

  /**
   * emits the changeEvent to the upper instance (RxCollection)
   */
  $emit: function $emit(changeEvent) {
    return this.collection.$emit(changeEvent);
  },

  /**
   * returns observable of the value of the given path
   */
  get$: function get$(path) {
    if (path.includes('.item.')) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC1', {
        path: path
      });
    }

    if (path === this.primaryPath) throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC2'); // final fields cannot be modified and so also not observed

    if (this.collection.schema.finalFields.includes(path)) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC3', {
        path: path
      });
    }

    var schemaObj = this.collection.schema.getSchemaByObjectPath(path);

    if (!schemaObj) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC4', {
        path: path
      });
    }

    return this._dataSync$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_4__[/* map */ "a"])(function (data) {
      return object_path__WEBPACK_IMPORTED_MODULE_2___default.a.get(data, path);
    }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__[/* distinctUntilChanged */ "a"])());
  },

  /**
   * populate the given path
   */
  populate: function populate(path) {
    var schemaObj = this.collection.schema.getSchemaByObjectPath(path);
    var value = this.get(path);

    if (!value) {
      return Promise.resolve(null);
    }

    if (!schemaObj) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC5', {
        path: path
      });
    }

    if (!schemaObj.ref) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC6', {
        path: path,
        schemaObj: schemaObj
      });
    }

    var refCollection = this.collection.database.collections[schemaObj.ref];

    if (!refCollection) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC7', {
        ref: schemaObj.ref,
        path: path,
        schemaObj: schemaObj
      });
    }

    if (schemaObj.type === 'array') {
      return refCollection.findByIds(value).then(function (res) {
        var valuesIterator = res.values();
        return Array.from(valuesIterator);
      });
    } else {
      return refCollection.findOne(value).exec();
    }
  },

  /**
   * get data by objectPath
   */
  get: function get(objPath) {
    if (!this._data) return undefined;
    var valueObj = object_path__WEBPACK_IMPORTED_MODULE_2___default.a.get(this._data, objPath);
    valueObj = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* clone */ "d"])(valueObj); // direct return if array or non-object

    if (typeof valueObj !== 'object' || Array.isArray(valueObj)) return valueObj;
    defineGetterSetter(this.collection.schema, valueObj, objPath, this);
    return valueObj;
  },
  toJSON: function toJSON() {
    var withRevAndAttachments = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var data = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* clone */ "d"])(this._data);

    if (!withRevAndAttachments) {
      delete data._rev;
      delete data._attachments;
    }

    return data;
  },

  /**
   * set data by objectPath
   * This can only be called on temporary documents
   */
  set: function set(objPath, value) {
    // setters can only be used on temporary documents
    if (!this._isTemporary) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxTypeError */ "c"])('DOC16', {
        objPath: objPath,
        value: value
      });
    }

    if (typeof objPath !== 'string') {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxTypeError */ "c"])('DOC15', {
        objPath: objPath,
        value: value
      });
    } // if equal, do nothing


    if (Object.is(this.get(objPath), value)) return; // throw if nested without root-object

    var pathEls = objPath.split('.');
    pathEls.pop();
    var rootPath = pathEls.join('.');

    if (typeof object_path__WEBPACK_IMPORTED_MODULE_2___default.a.get(this._data, rootPath) === 'undefined') {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC10', {
        childpath: objPath,
        rootPath: rootPath
      });
    }

    object_path__WEBPACK_IMPORTED_MODULE_2___default.a.set(this._data, objPath, value);
    return this;
  },

  /**
   * updates document
   * @overwritten by plugin (optinal)
   * @param updateObj mongodb-like syntax
   */
  update: function update(_updateObj) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* pluginMissing */ "p"])('update');
  },
  putAttachment: function putAttachment() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* pluginMissing */ "p"])('attachments');
  },
  getAttachment: function getAttachment() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* pluginMissing */ "p"])('attachments');
  },
  allAttachments: function allAttachments() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* pluginMissing */ "p"])('attachments');
  },

  get allAttachments$() {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* pluginMissing */ "p"])('attachments');
  },

  /**
   * runs an atomic update over the document
   * @param function that takes the document-data and returns a new data-object
   */
  atomicUpdate: function atomicUpdate(mutationFunction) {
    var _this2 = this;

    return new Promise(function (res, rej) {
      _this2._atomicQueue = _this2._atomicQueue.then( /*#__PURE__*/_babel_runtime_helpers_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1___default()( /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default.a.mark(function _callee() {
        var done, oldData, newData;
        return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default.a.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                done = false; // we need a hacky while loop to stay incide the chain-link of _atomicQueue
                // while still having the option to run a retry on conflicts

              case 1:
                if (done) {
                  _context.next = 24;
                  break;
                }

                oldData = _this2._dataSync$.getValue();
                _context.prev = 3;
                _context.next = 6;
                return mutationFunction(Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* clone */ "d"])(_this2._dataSync$.getValue()), _this2);

              case 6:
                newData = _context.sent;

                if (_this2.collection) {
                  newData = _this2.collection.schema.fillObjectWithDefaults(newData);
                }

                _context.next = 10;
                return _this2._saveData(newData, oldData);

              case 10:
                done = true;
                _context.next = 22;
                break;

              case 13:
                _context.prev = 13;
                _context.t0 = _context["catch"](3);

                if (!Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* isPouchdbConflictError */ "a"])(_context.t0)) {
                  _context.next = 20;
                  break;
                }

                _context.next = 18;
                return Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* nextTick */ "m"])();

              case 18:
                _context.next = 22;
                break;

              case 20:
                rej(_context.t0);
                return _context.abrupt("return");

              case 22:
                _context.next = 1;
                break;

              case 24:
                res(_this2);

              case 25:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[3, 13]]);
      })));
    });
  },

  /**
   * patches the given properties
   */
  atomicPatch: function atomicPatch(patch) {
    return this.atomicUpdate(function (docData) {
      Object.entries(patch).forEach(function (_ref2) {
        var k = _ref2[0],
            v = _ref2[1];
        docData[k] = v;
      });
      return docData;
    });
  },

  /**
   * @deprecated use atomicPatch instead because it is better typed
   * and does not allow any keys and values
   */
  atomicSet: function atomicSet(key, value) {
    return this.atomicUpdate(function (docData) {
      object_path__WEBPACK_IMPORTED_MODULE_2___default.a.set(docData, key, value);
      return docData;
    });
  },

  /**
   * saves the new document-data
   * and handles the events
   */
  _saveData: function _saveData(newData, oldData) {
    var _this3 = this;

    newData = newData; // deleted documents cannot be changed

    if (this._deleted$.getValue()) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC11', {
        id: this.primary,
        document: this
      });
    } // ensure modifications are ok


    this.collection.schema.validateChange(oldData, newData);
    var startTime;
    return this.collection._runHooks('pre', 'save', newData, this).then(function () {
      _this3.collection.schema.validate(newData);

      startTime = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* now */ "n"])();
      return _this3.collection._pouchPut(newData);
    }).then(function (ret) {
      var endTime = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* now */ "n"])();

      if (!ret.ok) {
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC12', {
          data: ret
        });
      }

      newData._rev = ret.rev; // emit event

      var changeEvent = Object(_rx_change_event__WEBPACK_IMPORTED_MODULE_7__[/* createUpdateEvent */ "e"])(_this3.collection, newData, oldData, startTime, endTime, _this3);

      _this3.$emit(changeEvent);

      return _this3.collection._runHooks('post', 'save', newData, _this3);
    });
  },

  /**
   * saves the temporary document and makes a non-temporary out of it
   * Saving a temporary doc is basically the same as RxCollection.insert()
   * @return false if nothing to save
   */
  save: function save() {
    var _this4 = this;

    // .save() cannot be called on non-temporary-documents
    if (!this._isTemporary) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC17', {
        id: this.primary,
        document: this
      });
    }

    return this.collection.insert(this).then(function () {
      _this4._isTemporary = false;

      _this4.collection._docCache.set(_this4.primary, _this4); // internal events


      _this4._dataSync$.next(_this4._data);

      return true;
    });
  },

  /**
   * remove the document,
   * this not not equal to a pouchdb.remove(),
   * instead we keep the values and only set _deleted: true
   */
  remove: function remove() {
    var _this5 = this;

    if (this.deleted) {
      return Promise.reject(Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC13', {
        document: this,
        id: this.primary
      }));
    }

    var deletedData = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* clone */ "d"])(this._data);
    var startTime;
    return this.collection._runHooks('pre', 'remove', deletedData, this).then(function () {
      deletedData._deleted = true;
      startTime = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* now */ "n"])();
      /**
       * because pouch.remove will also empty the object,
       * we set _deleted: true and use pouch.put
       */

      return _this5.collection._pouchPut(deletedData);
    }).then(function () {
      var endTime = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* now */ "n"])();

      _this5.$emit(Object(_rx_change_event__WEBPACK_IMPORTED_MODULE_7__[/* createDeleteEvent */ "c"])(_this5.collection, deletedData, _this5._data, startTime, endTime, _this5));

      return _this5.collection._runHooks('post', 'remove', deletedData, _this5);
    }).then(function () {
      return _this5;
    });
  },
  destroy: function destroy() {
    throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_8__[/* newRxError */ "b"])('DOC14');
  }
};
function createRxDocumentConstructor() {
  var proto = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : basePrototype;

  var constructor = function RxDocumentConstructor(collection, jsonData) {
    this.collection = collection; // if true, this is a temporary document

    this._isTemporary = false; // assume that this is always equal to the doc-data in the database

    this._dataSync$ = new rxjs__WEBPACK_IMPORTED_MODULE_3__[/* BehaviorSubject */ "a"](jsonData);
    this._deleted$ = new rxjs__WEBPACK_IMPORTED_MODULE_3__[/* BehaviorSubject */ "a"](false);
    this._atomicQueue = Promise.resolve();
    /**
     * because of the prototype-merge,
     * we can not use the native instanceof operator
     */

    this.isInstanceOfRxDocument = true;
  };

  constructor.prototype = proto;
  return constructor;
}
function defineGetterSetter(schema, valueObj) {
  var objPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var thisObj = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  if (valueObj === null) return;
  var pathProperties = schema.getSchemaByObjectPath(objPath);
  if (typeof pathProperties === 'undefined') return;
  if (pathProperties.properties) pathProperties = pathProperties.properties;
  Object.keys(pathProperties).forEach(function (key) {
    var fullPath = Object(_util__WEBPACK_IMPORTED_MODULE_6__[/* trimDots */ "A"])(objPath + '.' + key); // getter - value

    valueObj.__defineGetter__(key, function () {
      var _this = thisObj ? thisObj : this;

      if (!_this.get || typeof _this.get !== 'function') {
        /**
         * When an object gets added to the state of a vuejs-component,
         * it happens that this getter is called with another scope.
         * To prevent errors, we have to return undefined in this case
         */
        return undefined;
      }

      var ret = _this.get(fullPath);

      return ret;
    }); // getter - observable$


    Object.defineProperty(valueObj, key + '$', {
      get: function get() {
        var _this = thisObj ? thisObj : this;

        return _this.get$(fullPath);
      },
      enumerable: false,
      configurable: false
    }); // getter - populate_

    Object.defineProperty(valueObj, key + '_', {
      get: function get() {
        var _this = thisObj ? thisObj : this;

        return _this.populate(fullPath);
      },
      enumerable: false,
      configurable: false
    }); // setter - value

    valueObj.__defineSetter__(key, function (val) {
      var _this = thisObj ? thisObj : this;

      return _this.set(fullPath, val);
    });
  });
}
function createWithConstructor(constructor, collection, jsonData) {
  if (jsonData[collection.schema.primaryPath] && jsonData[collection.schema.primaryPath].startsWith('_design')) return null;
  var doc = new constructor(collection, jsonData);
  Object(_hooks__WEBPACK_IMPORTED_MODULE_9__[/* runPluginHooks */ "d"])('createRxDocument', doc);
  return doc;
}
function isInstanceOf(obj) {
  if (typeof obj === 'undefined') return false;
  return !!obj.isInstanceOfRxDocument;
}
//# sourceMappingURL=rx-document.js.map

/***/ }),

/***/ "723f":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export RxStoragePouchDbClass */
/* unused harmony export primarySwapPouchDbQuerySelector */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return getPouchLocation; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return getRxStoragePouchDb; });
/* harmony import */ var pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("abd4");
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("02aa");
/* harmony import */ var _hooks__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("ac6e");
/* harmony import */ var _pouch_db__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("d79b");
/* harmony import */ var _rx_error__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("7733");





var RxStoragePouchDbClass = /*#__PURE__*/function () {
  function RxStoragePouchDbClass(adapter) {
    var pouchSettings = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    this.name = 'pouchdb';
    this.adapter = adapter;
    this.pouchSettings = pouchSettings;
  }

  var _proto = RxStoragePouchDbClass.prototype;

  _proto.getSortComparator = function getSortComparator(primaryKey, query) {
    var _ref;

    var sortOptions = query.sort ? query.sort : [(_ref = {}, _ref[primaryKey] = 'asc', _ref)];
    var massagedSelector = Object(pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_0__[/* massageSelector */ "f"])(query.selector);
    var inMemoryFields = Object.keys(query.selector);

    var fun = function fun(a, b) {
      // TODO use createFieldSorter
      // TODO make a performance test
      var rows = [a, b].map(function (doc) {
        // swap primary to _id
        var cloned = Object(_util__WEBPACK_IMPORTED_MODULE_1__[/* flatClone */ "f"])(doc);
        var primaryValue = cloned[primaryKey];
        delete cloned[primaryKey];
        cloned._id = primaryValue;
        return {
          doc: cloned
        };
      });
      var sortedRows = Object(pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_0__[/* filterInMemoryFields */ "b"])(rows, {
        selector: massagedSelector,
        sort: sortOptions
      }, inMemoryFields);

      if (sortedRows[0].doc._id === rows[0].doc._id) {
        return -1;
      } else {
        return 1;
      }
    };

    return fun;
  }
  /**
   * @link https://github.com/pouchdb/pouchdb/blob/master/packages/node_modules/pouchdb-selector-core/src/matches-selector.js
   */
  ;

  _proto.getQueryMatcher = function getQueryMatcher(primaryKey, query) {
    var massagedSelector = Object(pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_0__[/* massageSelector */ "f"])(query.selector);

    var fun = function fun(doc) {
      // swap primary to _id
      var cloned = Object(_util__WEBPACK_IMPORTED_MODULE_1__[/* flatClone */ "f"])(doc);
      var primaryValue = cloned[primaryKey];
      delete cloned[primaryKey];
      cloned._id = primaryValue;
      var row = {
        doc: cloned
      };
      var rowsMatched = Object(pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_0__[/* filterInMemoryFields */ "b"])([row], {
        selector: massagedSelector
      }, Object.keys(query.selector));
      return rowsMatched && rowsMatched.length === 1;
    };

    return fun;
  };

  _proto.createStorageInstance = function createStorageInstance(databaseName, collectionName, schemaVersion) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    if (!options.pouchSettings) {
      options.pouchSettings = {};
    }

    var pouchLocation = getPouchLocation(databaseName, collectionName, schemaVersion);
    var pouchDbParameters = {
      location: pouchLocation,
      adapter: Object(_util__WEBPACK_IMPORTED_MODULE_1__[/* adapterObject */ "c"])(this.adapter),
      settings: options.pouchSettings
    };
    var pouchDBOptions = Object.assign({}, pouchDbParameters.adapter, this.pouchSettings, pouchDbParameters.settings);
    Object(_hooks__WEBPACK_IMPORTED_MODULE_2__[/* runPluginHooks */ "d"])('preCreatePouchDb', pouchDbParameters);
    return new _pouch_db__WEBPACK_IMPORTED_MODULE_3__[/* PouchDB */ "a"](pouchDbParameters.location, pouchDBOptions);
  };

  _proto.createInternalStorageInstance = function createInternalStorageInstance(databaseName, _options) {
    var storageInstance = this.createStorageInstance(databaseName, '_rxdb_internal', 0, {
      pouchSettings: {
        // no compaction because this only stores local documents
        auto_compaction: false,
        revs_limit: 1
      }
    });
    return Promise.resolve(storageInstance);
  }
  /**
   * pouchdb has many bugs and strange behaviors
   * this functions takes a normal mango query
   * and transforms it to one that fits for pouchdb
   */
  ;

  _proto.prepareQuery = function prepareQuery(rxQuery, mutateableQuery) {
    var primPath = rxQuery.collection.schema.primaryPath;
    var query = mutateableQuery;
    /**
     * because sort wont work on unused keys we have to workaround
     * so we add the key to the selector if necessary
     * @link https://github.com/nolanlawson/pouchdb-find/issues/204
     */

    if (query.sort) {
      query.sort.forEach(function (sortPart) {
        var key = Object.keys(sortPart)[0];
        var comparisonOperators = ['$gt', '$gte', '$lt', '$lte'];
        var keyUsed = query.selector[key] && Object.keys(query.selector[key]).some(function (op) {
          return comparisonOperators.includes(op);
        }) || false;

        if (!keyUsed) {
          var schemaObj = rxQuery.collection.schema.getSchemaByObjectPath(key);

          if (!schemaObj) {
            throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_4__[/* newRxError */ "b"])('QU5', {
              key: key
            });
          }

          if (!query.selector[key]) {
            query.selector[key] = {};
          }

          switch (schemaObj.type) {
            case 'number':
            case 'integer':
              // TODO change back to -Infinity when issue resolved
              // @link https://github.com/pouchdb/pouchdb/issues/6454
              // -Infinity does not work since pouchdb 6.2.0
              query.selector[key].$gt = -9999999999999999999999999999;
              break;

            case 'string':
              /**
               * strings need an empty string, see
               * @link https://github.com/pubkey/rxdb/issues/585
               */
              if (typeof query.selector[key] !== 'string') {
                query.selector[key].$gt = '';
              }

              break;

            default:
              query.selector[key].$gt = null;
              break;
          }
        }
      });
    } // regex does not work over the primary key
    // TODO move this to dev mode


    if (query.selector[primPath] && query.selector[primPath].$regex) {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_4__[/* newRxError */ "b"])('QU4', {
        path: primPath,
        query: rxQuery.mangoQuery
      });
    } // primary-swap sorting


    if (query.sort) {
      var sortArray = query.sort.map(function (part) {
        var _newPart;

        var key = Object.keys(part)[0];
        var direction = Object.values(part)[0];
        var useKey = key === primPath ? '_id' : key;
        var newPart = (_newPart = {}, _newPart[useKey] = direction, _newPart);
        return newPart;
      });
      query.sort = sortArray;
    } // strip empty selectors


    Object.entries(query.selector).forEach(function (_ref2) {
      var k = _ref2[0],
          v = _ref2[1];

      if (typeof v === 'object' && v !== null && !Array.isArray(v) && Object.keys(v).length === 0) {
        delete query.selector[k];
      }
    });

    if (primPath !== '_id') {
      query.selector = primarySwapPouchDbQuerySelector(query.selector, primPath);
    }

    return query;
  };

  return RxStoragePouchDbClass;
}();
/**
 * Runs a primary swap with transform all custom primaryKey occurences
 * into '_id'
 * @recursive
 */

function primarySwapPouchDbQuerySelector(selector, primaryKey) {
  if (Array.isArray(selector)) {
    return selector.map(function (item) {
      return primarySwapPouchDbQuerySelector(item, primaryKey);
    });
  } else if (typeof selector === 'object') {
    var ret = {};
    Object.entries(selector).forEach(function (_ref3) {
      var k = _ref3[0],
          v = _ref3[1];

      if (k === primaryKey) {
        ret._id = v;
      } else {
        if (k.startsWith('$')) {
          ret[k] = primarySwapPouchDbQuerySelector(v, primaryKey);
        } else {
          ret[k] = v;
        }
      }
    });
    return ret;
  } else {
    return selector;
  }
}
/**
 * returns the pouchdb-database-name
 */

function getPouchLocation(dbName, collectionName, schemaVersion) {
  var prefix = dbName + '-rxdb-' + schemaVersion + '-';

  if (!collectionName.includes('/')) {
    return prefix + collectionName;
  } else {
    // if collectionName is a path, we have to prefix the last part only
    var split = collectionName.split('/');
    var last = split.pop();
    var ret = split.join('/');
    ret += '/' + prefix + last;
    return ret;
  }
}
function getRxStoragePouchDb(adapter, pouchSettings) {
  if (!adapter) {
    throw new Error('adapter missing');
  }

  return new RxStoragePouchDbClass(adapter, pouchSettings);
}
//# sourceMappingURL=rx-storage-pouchdb.js.map

/***/ }),

/***/ "7559":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RxQueryBase; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return _getDefaultQuery; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return tunnelQueryCache; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return createRxQuery; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return isInstanceOf; });
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("63d2");
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var deep_equal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("d3a7");
/* harmony import */ var deep_equal__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(deep_equal__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("2e21");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("810b");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("d8cb");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("e076");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("cf9c");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("260e");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__("5374");
/* harmony import */ var pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__("abd4");
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__("02aa");
/* harmony import */ var _rx_error__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__("7733");
/* harmony import */ var _hooks__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__("ac6e");
/* harmony import */ var _rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__("2a87");
/* harmony import */ var _event_reduce__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__("41cc");
/* harmony import */ var _query_cache__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__("c427");











var _queryCount = 0;

var newQueryID = function newQueryID() {
  return ++_queryCount;
};

var RxQueryBase = /*#__PURE__*/function () {
  /**
   * Some stats then are used for debugging and cache replacement policies
   */
  // used by some plugins
  // used to count the subscribers to the query
  function RxQueryBase(op, mangoQuery, collection) {
    this.id = newQueryID();
    this._execOverDatabaseCount = 0;
    this._creationTime = Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* now */ "n"])();
    this._lastEnsureEqual = 0;
    this.other = {};
    this.uncached = false;
    this.refCount$ = new rxjs__WEBPACK_IMPORTED_MODULE_2__[/* BehaviorSubject */ "a"](null);
    this._latestChangeEvent = -1;
    this._resultsData = null;
    this._resultsDataMap = new Map();
    this._lastExecStart = 0;
    this._lastExecEnd = 0;
    this._resultsDocs$ = new rxjs__WEBPACK_IMPORTED_MODULE_2__[/* BehaviorSubject */ "a"](null);
    this._ensureEqualQueue = Promise.resolve(false);
    this.op = op;
    this.mangoQuery = mangoQuery;
    this.collection = collection;

    if (!mangoQuery) {
      mangoQuery = _getDefaultQuery(this.collection);
    }
  }

  var _proto = RxQueryBase.prototype;

  /**
   * set the new result-data as result-docs of the query
   * @param newResultData json-docs that were recieved from pouchdb
   */
  _proto._setResultData = function _setResultData(newResultData) {
    this._resultsData = newResultData;
    var docs = Object(_rx_document_prototype_merge__WEBPACK_IMPORTED_MODULE_13__[/* createRxDocuments */ "b"])(this.collection, this._resultsData);

    this._resultsDocs$.next(docs);

    return docs;
  }
  /**
   * executes the query on the database
   * @return results-array with document-data
   */
  ;

  _proto._execOverDatabase = function _execOverDatabase() {
    var _this = this;

    this._execOverDatabaseCount = this._execOverDatabaseCount + 1;
    this._lastExecStart = Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* now */ "n"])();
    var docsPromise;

    switch (this.op) {
      case 'find':
        docsPromise = this.collection._pouchFind(this);
        break;

      case 'findOne':
        docsPromise = this.collection._pouchFind(this, 1);
        break;

      default:
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_11__[/* newRxError */ "b"])('QU1', {
          op: this.op
        });
    }

    return docsPromise.then(function (docs) {
      _this._lastExecEnd = Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* now */ "n"])();
      _this._resultsDataMap = new Map();
      var primPath = _this.collection.schema.primaryPath;
      docs.forEach(function (doc) {
        var id = doc[primPath];

        _this._resultsDataMap.set(id, doc);
      });
      return docs;
    });
  }
  /**
   * Execute the query
   * To have an easier implementations,
   * just subscribe and use the first result
   */
  ;

  _proto.exec = function exec(throwIfMissing) {
    var _this2 = this;

    // TODO this should be ensured by typescript
    if (throwIfMissing && this.op !== 'findOne') {
      throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_11__[/* newRxError */ "b"])('QU9', {
        query: this.mangoQuery,
        op: this.op
      });
    }
    /**
     * run _ensureEqual() here,
     * this will make sure that errors in the query which throw inside of pouchdb,
     * will be thrown at this execution context
     */


    return _ensureEqual(this).then(function () {
      return _this2.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_4__[/* first */ "a"])()).toPromise();
    }).then(function (result) {
      if (!result && throwIfMissing) {
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_11__[/* newRxError */ "b"])('QU10', {
          query: _this2.mangoQuery,
          op: _this2.op
        });
      } else {
        return result;
      }
    });
  }
  /**
   * cached call to get the massageSelector
   * @overwrites itself with the actual value
   */
  ;

  /**
   * returns a string that is used for equal-comparisons
   * @overwrites itself with the actual value
   */
  _proto.toString = function toString() {
    var stringObj = Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* sortObject */ "x"])({
      op: this.op,
      query: this.mangoQuery,
      other: this.other
    }, true);
    var value = JSON.stringify(stringObj, _util__WEBPACK_IMPORTED_MODULE_10__[/* stringifyFilter */ "y"]);

    this.toString = function () {
      return value;
    };

    return value;
  }
  /**
   * returns the prepared query
   * @overwrites itself with the actual value
   */
  ;

  _proto.toJSON = function toJSON() {
    var value = this.collection.database.storage.prepareQuery(this.asRxQuery, Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* clone */ "d"])(this.mangoQuery));

    this.toJSON = function () {
      return value;
    };

    return value;
  }
  /**
   * returns the key-compressed version of the query
   * @overwrites itself with the actual value
   */
  ;

  _proto.keyCompress = function keyCompress() {
    var value;

    if (!this.collection.schema.doKeyCompression()) {
      value = this.toJSON();
    } else {
      value = this.collection._keyCompressor.compressQuery(this.toJSON());
    }

    this.keyCompress = function () {
      return value;
    };

    return value;
  }
  /**
   * returns true if the document matches the query,
   * does not use the 'skip' and 'limit'
   * // TODO this was moved to rx-storage
   */
  ;

  _proto.doesDocumentDataMatch = function doesDocumentDataMatch(docData) {
    // if doc is deleted, it cannot match
    if (docData._deleted) return false;
    docData = this.collection.schema.swapPrimaryToId(docData); // return matchesSelector(docData, selector);

    /**
     * the following is equal to the implementation of pouchdb
     * we do not use matchesSelector() directly so we can cache the
     * result of massageSelector
     * @link https://github.com/pouchdb/pouchdb/blob/master/packages/node_modules/pouchdb-selector-core/src/matches-selector.js
     */

    var selector = this.massageSelector;
    var row = {
      doc: docData
    };
    var rowsMatched = Object(pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_9__[/* filterInMemoryFields */ "b"])([row], {
      selector: selector
    }, Object.keys(selector));
    return rowsMatched && rowsMatched.length === 1;
  }
  /**
   * deletes all found documents
   * @return promise with deleted documents
   */
  ;

  _proto.remove = function remove() {
    var ret;
    return this.exec().then(function (docs) {
      ret = docs;
      if (Array.isArray(docs)) return Promise.all(docs.map(function (doc) {
        return doc.remove();
      }));else return docs.remove();
    }).then(function () {
      return ret;
    });
  }
  /**
   * helper function to transform RxQueryBase to RxQuery type
   */
  ;

  /**
   * updates all found documents
   * @overwritten by plugin (optional)
   */
  _proto.update = function update(_updateObj) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* pluginMissing */ "p"])('update');
  } // we only set some methods of query-builder here
  // because the others depend on these ones
  ;

  _proto.where = function where(_queryObj) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* pluginMissing */ "p"])('query-builder');
  };

  _proto.sort = function sort(_params) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* pluginMissing */ "p"])('query-builder');
  };

  _proto.skip = function skip(_amount) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* pluginMissing */ "p"])('query-builder');
  };

  _proto.limit = function limit(_amount) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* pluginMissing */ "p"])('query-builder');
  };

  _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default()(RxQueryBase, [{
    key: "$",
    get: function get() {
      var _this3 = this;

      if (!this._$) {
        /**
         * We use _resultsDocs$ to emit new results
         * This also ensure that there is a reemit on subscribe
         */
        var results$ = this._resultsDocs$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__[/* mergeMap */ "b"])(function (docs) {
          return _ensureEqual(_this3).then(function (hasChanged) {
            if (hasChanged) return false; // wait for next emit
            else return docs;
          });
        }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_6__[/* filter */ "a"])(function (docs) {
          return !!docs;
        }), // not if previous returned false
        Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_7__[/* map */ "a"])(function (docs) {
          // findOne()-queries emit document or null
          if (_this3.op === 'findOne') {
            var doc = docs.length === 0 ? null : docs[0];
            return doc;
          } else return docs; // find()-queries emit RxDocument[]

        }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_7__[/* map */ "a"])(function (docs) {
          // copy the array so it wont matter if the user modifies it
          var ret = Array.isArray(docs) ? docs.slice() : docs;
          return ret;
        }))['asObservable']();
        /**
         * subscribe to the changeEvent-stream so it detects changes if it has subscribers
         */


        var changeEvents$ = this.collection.$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_8__[/* tap */ "a"])(function () {
          return _ensureEqual(_this3);
        }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_6__[/* filter */ "a"])(function () {
          return false;
        }));
        this._$ = // tslint:disable-next-line
        Object(rxjs__WEBPACK_IMPORTED_MODULE_3__[/* merge */ "a"])(results$, changeEvents$, this.refCount$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_6__[/* filter */ "a"])(function () {
          return false;
        })));
      }

      return this._$;
    } // stores the changeEvent-Number of the last handled change-event

  }, {
    key: "massageSelector",
    get: function get() {
      return Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* overwriteGetterForCaching */ "o"])(this, 'massageSelector', Object(pouchdb_selector_core__WEBPACK_IMPORTED_MODULE_9__[/* massageSelector */ "f"])(this.mangoQuery.selector));
    }
  }, {
    key: "asRxQuery",
    get: function get() {
      return this;
    }
  }]);

  return RxQueryBase;
}();
function _getDefaultQuery(collection) {
  var _selector;

  return {
    selector: (_selector = {}, _selector[collection.schema.primaryPath] = {}, _selector)
  };
}
/**
 * run this query through the QueryCache
 */

function tunnelQueryCache(rxQuery) {
  return rxQuery.collection._queryCache.getByQuery(rxQuery);
}
function createRxQuery(op, queryObj, collection) {
  // checks
  if (queryObj && typeof queryObj !== 'object') {
    throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_11__[/* newRxTypeError */ "c"])('QU7', {
      queryObj: queryObj
    });
  }

  if (Array.isArray(queryObj)) {
    throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_11__[/* newRxTypeError */ "c"])('QU8', {
      queryObj: queryObj
    });
  }

  Object(_hooks__WEBPACK_IMPORTED_MODULE_12__[/* runPluginHooks */ "d"])('preCreateRxQuery', {
    op: op,
    queryObj: queryObj,
    collection: collection
  });
  var ret = new RxQueryBase(op, queryObj, collection); // ensure when created with same params, only one is created

  ret = tunnelQueryCache(ret);
  Object(_hooks__WEBPACK_IMPORTED_MODULE_12__[/* runPluginHooks */ "d"])('createRxQuery', ret);
  Object(_query_cache__WEBPACK_IMPORTED_MODULE_15__[/* triggerCacheReplacement */ "k"])(collection);
  return ret;
}
/**
 * check if the current results-state is in sync with the database
 * @return false if not which means it should re-execute
 */

function _isResultsInSync(rxQuery) {
  if (rxQuery._latestChangeEvent >= rxQuery.collection._changeEventBuffer.counter) {
    return true;
  } else return false;
}
/**
 * wraps __ensureEqual()
 * to ensure it does not run in parallel
 * @return true if has changed, false if not
 */


function _ensureEqual(rxQuery) {
  rxQuery._ensureEqualQueue = rxQuery._ensureEqualQueue.then(function () {
    return new Promise(function (res) {
      return setTimeout(res, 0);
    });
  }).then(function () {
    return __ensureEqual(rxQuery);
  }).then(function (ret) {
    return new Promise(function (res) {
      return setTimeout(res, 0);
    }).then(function () {
      return ret;
    });
  });
  return rxQuery._ensureEqualQueue;
}
/**
 * ensures that the results of this query is equal to the results which a query over the database would give
 * @return true if results have changed
 */


function __ensureEqual(rxQuery) {
  rxQuery._lastEnsureEqual = Object(_util__WEBPACK_IMPORTED_MODULE_10__[/* now */ "n"])();
  if (rxQuery.collection.database.destroyed) return false; // db is closed

  if (_isResultsInSync(rxQuery)) return false; // nothing happend

  var ret = false;
  var mustReExec = false; // if this becomes true, a whole execution over the database is made

  if (rxQuery._latestChangeEvent === -1) mustReExec = true; // have not executed yet -> must run

  /**
   * try to use the queryChangeDetector to calculate the new results
   */

  if (!mustReExec) {
    var missedChangeEvents = rxQuery.collection._changeEventBuffer.getFrom(rxQuery._latestChangeEvent + 1);

    if (missedChangeEvents === null) {
      // changeEventBuffer is of bounds -> we must re-execute over the database
      mustReExec = true;
    } else {
      rxQuery._latestChangeEvent = rxQuery.collection._changeEventBuffer.counter;
      /**
       * because pouchdb prefers writes over reads,
       * we have to filter out the events that happend before the read has started
       * so that we do not fill event-reduce with the wrong data
       */

      missedChangeEvents = missedChangeEvents.filter(function (cE) {
        return !cE.startTime || cE.startTime > rxQuery._lastExecStart;
      });

      var runChangeEvents = rxQuery.collection._changeEventBuffer.reduceByLastOfDoc(missedChangeEvents);
      /*
      console.log('calculateNewResults() ' + new Date().getTime());
      console.log(rxQuery._lastExecStart + ' - ' + rxQuery._lastExecEnd);
      console.dir(rxQuery._resultsData.slice());
      console.dir(runChangeEvents);
      */


      var eventReduceResult = Object(_event_reduce__WEBPACK_IMPORTED_MODULE_14__[/* calculateNewResults */ "a"])(rxQuery, runChangeEvents);

      if (eventReduceResult.runFullQueryAgain) {
        // could not calculate the new results, execute must be done
        mustReExec = true;
      } else if (eventReduceResult.changed) {
        // we got the new results, we do not have to re-execute, mustReExec stays false
        ret = true; // true because results changed

        rxQuery._setResultData(eventReduceResult.newResults);
      }
    }
  } // oh no we have to re-execute the whole query over the database


  if (mustReExec) {
    // counter can change while _execOverDatabase() is running so we save it here
    var latestAfter = rxQuery.collection._changeEventBuffer.counter;
    return rxQuery._execOverDatabase().then(function (newResultData) {
      rxQuery._latestChangeEvent = latestAfter;

      if (!deep_equal__WEBPACK_IMPORTED_MODULE_1___default()(newResultData, rxQuery._resultsData)) {
        ret = true; // true because results changed

        rxQuery._setResultData(newResultData);
      }

      return ret;
    });
  }

  return ret; // true if results have changed
}

function isInstanceOf(obj) {
  return obj instanceof RxQueryBase;
}
//# sourceMappingURL=rx-query.js.map

/***/ }),

/***/ "7733":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export RxError */
/* unused harmony export RxTypeError */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return newRxError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return newRxTypeError; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return isPouchdbConflictError; });
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("63d2");
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _babel_runtime_helpers_inheritsLoose__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("5bf2");
/* harmony import */ var _babel_runtime_helpers_inheritsLoose__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_inheritsLoose__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _babel_runtime_helpers_wrapNativeSuper__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("980c");
/* harmony import */ var _babel_runtime_helpers_wrapNativeSuper__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_wrapNativeSuper__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _overwritable__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("e73d");




/**
 * here we use custom errors with the additional field 'parameters'
 */


/**
 * transform an object of parameters to a presentable string
 */
function parametersToString(parameters) {
  var ret = '';
  if (Object.keys(parameters).length === 0) return ret;
  ret += 'Given parameters: {\n';
  ret += Object.keys(parameters).map(function (k) {
    var paramStr = '[object Object]';

    try {
      paramStr = JSON.stringify(parameters[k], function (_k, v) {
        return v === undefined ? null : v;
      }, 2);
    } catch (e) {}

    return k + ':' + paramStr;
  }).join('\n');
  ret += '}';
  return ret;
}

function messageForError(message, code, parameters) {
  return 'RxError (' + code + '):' + '\n' + message + '\n' + parametersToString(parameters);
}

var RxError = /*#__PURE__*/function (_Error) {
  _babel_runtime_helpers_inheritsLoose__WEBPACK_IMPORTED_MODULE_1___default()(RxError, _Error);

  function RxError(code, message) {
    var _this;

    var parameters = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var mes = messageForError(message, code, parameters);
    _this = _Error.call(this, mes) || this;
    _this.code = code;
    _this.message = mes;
    _this.parameters = parameters;
    _this.rxdb = true; // tag them as internal

    return _this;
  }

  var _proto = RxError.prototype;

  _proto.toString = function toString() {
    return this.message;
  };

  _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default()(RxError, [{
    key: "name",
    get: function get() {
      return 'RxError (' + this.code + ')';
    }
  }, {
    key: "typeError",
    get: function get() {
      return false;
    }
  }]);

  return RxError;
}( /*#__PURE__*/_babel_runtime_helpers_wrapNativeSuper__WEBPACK_IMPORTED_MODULE_2___default()(Error));
var RxTypeError = /*#__PURE__*/function (_TypeError) {
  _babel_runtime_helpers_inheritsLoose__WEBPACK_IMPORTED_MODULE_1___default()(RxTypeError, _TypeError);

  function RxTypeError(code, message) {
    var _this2;

    var parameters = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var mes = messageForError(message, code, parameters);
    _this2 = _TypeError.call(this, mes) || this;
    _this2.code = code;
    _this2.message = mes;
    _this2.parameters = parameters;
    _this2.rxdb = true; // tag them as internal

    return _this2;
  }

  var _proto2 = RxTypeError.prototype;

  _proto2.toString = function toString() {
    return this.message;
  };

  _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default()(RxTypeError, [{
    key: "name",
    get: function get() {
      return 'RxTypeError (' + this.code + ')';
    }
  }, {
    key: "typeError",
    get: function get() {
      return true;
    }
  }]);

  return RxTypeError;
}( /*#__PURE__*/_babel_runtime_helpers_wrapNativeSuper__WEBPACK_IMPORTED_MODULE_2___default()(TypeError));
function newRxError(code, parameters) {
  return new RxError(code, _overwritable__WEBPACK_IMPORTED_MODULE_3__[/* overwritable */ "a"].tunnelErrorMessage(code), parameters);
}
function newRxTypeError(code, parameters) {
  return new RxTypeError(code, _overwritable__WEBPACK_IMPORTED_MODULE_3__[/* overwritable */ "a"].tunnelErrorMessage(code), parameters);
}
function isPouchdbConflictError(err) {
  if (err.parameters && err.parameters.pouchDbError && err.parameters.pouchDbError.status === 409) {
    return true;
  } else {
    return false;
  }
}
//# sourceMappingURL=rx-error.js.map

/***/ }),

/***/ "7e30":
/***/ (function(module, exports) {


//# sourceMappingURL=random-token.d.js.map

/***/ }),

/***/ "a263":
/***/ (function(module, exports) {


//# sourceMappingURL=pouchdb-selector-core.d.js.map

/***/ }),

/***/ "ab32":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RxSchema; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return getIndexes; });
/* unused harmony export getPrimary */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return getPreviousVersions; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return getFinalFields; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return normalize; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return fillWithDefaultSettings; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return createRxSchema; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return isInstanceOf; });
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("63d2");
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var object_path__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("3f90");
/* harmony import */ var object_path__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(object_path__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var deep_equal__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("d3a7");
/* harmony import */ var deep_equal__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(deep_equal__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("02aa");
/* harmony import */ var _rx_error__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("7733");
/* harmony import */ var _hooks__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("ac6e");
/* harmony import */ var _rx_document__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("6c14");







var RxSchema = /*#__PURE__*/function () {
  function RxSchema(jsonSchema) {
    this.jsonSchema = jsonSchema;
    this.indexes = getIndexes(this.jsonSchema); // primary is always required

    this.primaryPath = getPrimary(this.jsonSchema);

    if (this.primaryPath) {
      this.jsonSchema.required.push(this.primaryPath);
    } // final fields are always required


    this.finalFields = getFinalFields(this.jsonSchema);
    this.jsonSchema.required = this.jsonSchema.required.concat(this.finalFields).filter(function (elem, pos, arr) {
      return arr.indexOf(elem) === pos;
    }); // unique;
    // add primary to schema if not there (if _id)

    if (!this.jsonSchema.properties[this.primaryPath]) {
      this.jsonSchema.properties[this.primaryPath] = {
        type: 'string',
        minLength: 1
      };
    }
  }

  var _proto = RxSchema.prototype;

  _proto.getSchemaByObjectPath = function getSchemaByObjectPath(path) {
    var usePath = path;
    usePath = usePath.replace(/\./g, '.properties.');
    usePath = 'properties.' + usePath;
    usePath = Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* trimDots */ "A"])(usePath);
    var ret = object_path__WEBPACK_IMPORTED_MODULE_1___default.a.get(this.jsonSchema, usePath);
    return ret;
  }
  /**
   * checks if a given change on a document is allowed
   * Ensures that:
   * - primary is not modified
   * - final fields are not modified
   * @throws {Error} if not valid
   */
  ;

  _proto.validateChange = function validateChange(dataBefore, dataAfter) {
    this.finalFields.forEach(function (fieldName) {
      if (!deep_equal__WEBPACK_IMPORTED_MODULE_2___default()(dataBefore[fieldName], dataAfter[fieldName])) {
        throw Object(_rx_error__WEBPACK_IMPORTED_MODULE_4__[/* newRxError */ "b"])('DOC9', {
          dataBefore: dataBefore,
          dataAfter: dataAfter,
          fieldName: fieldName
        });
      }
    });
  }
  /**
   * validate if the obj matches the schema
   * @overwritten by plugin (required)
   * @param schemaPath if given, validates agains deep-path of schema
   * @throws {Error} if not valid
   * @param obj equal to input-obj
   */
  ;

  _proto.validate = function validate(_obj, _schemaPath) {
    throw Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* pluginMissing */ "p"])('validate');
  }
  /**
   * fills all unset fields with default-values if set
   */
  ;

  _proto.fillObjectWithDefaults = function fillObjectWithDefaults(obj) {
    obj = Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* clone */ "d"])(obj);
    Object.entries(this.defaultValues).filter(function (_ref) {
      var k = _ref[0];
      return !obj.hasOwnProperty(k) || typeof obj[k] === 'undefined';
    }).forEach(function (_ref2) {
      var k = _ref2[0],
          v = _ref2[1];
      return obj[k] = v;
    });
    return obj;
  };

  _proto.swapIdToPrimary = function swapIdToPrimary(obj) {
    if (this.primaryPath === '_id' || obj[this.primaryPath]) {
      return obj;
    }

    obj[this.primaryPath] = obj._id;
    delete obj._id;
    return obj;
  };

  _proto.swapPrimaryToId = function swapPrimaryToId(obj) {
    var _this = this;

    if (this.primaryPath === '_id') {
      return obj;
    }

    var ret = {};
    Object.entries(obj).forEach(function (entry) {
      var newKey = entry[0] === _this.primaryPath ? '_id' : entry[0];
      ret[newKey] = entry[1];
    });
    return ret;
  }
  /**
   * returns true if key-compression should be done
   */
  ;

  _proto.doKeyCompression = function doKeyCompression() {
    return this.jsonSchema.keyCompression;
  }
  /**
   * creates the schema-based document-prototype,
   * see RxCollection.getDocumentPrototype()
   */
  ;

  _proto.getDocumentPrototype = function getDocumentPrototype() {
    var proto = {};
    Object(_rx_document__WEBPACK_IMPORTED_MODULE_6__[/* defineGetterSetter */ "d"])(this, proto, '');
    Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* overwriteGetterForCaching */ "o"])(this, 'getDocumentPrototype', function () {
      return proto;
    });
    return proto;
  };

  _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_0___default()(RxSchema, [{
    key: "version",
    get: function get() {
      return this.jsonSchema.version;
    }
  }, {
    key: "normalized",
    get: function get() {
      return Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* overwriteGetterForCaching */ "o"])(this, 'normalized', normalize(this.jsonSchema));
    }
  }, {
    key: "topLevelFields",
    get: function get() {
      return Object.keys(this.normalized.properties);
    }
  }, {
    key: "defaultValues",
    get: function get() {
      var values = {};
      Object.entries(this.normalized.properties).filter(function (_ref3) {
        var v = _ref3[1];
        return v.hasOwnProperty('default');
      }).forEach(function (_ref4) {
        var k = _ref4[0],
            v = _ref4[1];
        return values[k] = v["default"];
      });
      return Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* overwriteGetterForCaching */ "o"])(this, 'defaultValues', values);
    }
    /**
        * true if schema contains at least one encrypted path
        */

  }, {
    key: "crypt",
    get: function get() {
      if (!!this.jsonSchema.encrypted && this.jsonSchema.encrypted.length > 0 || this.jsonSchema.attachments && this.jsonSchema.attachments.encrypted) {
        return true;
      } else {
        return false;
      }
    }
    /**
     * get all encrypted paths
     */

  }, {
    key: "encryptedPaths",
    get: function get() {
      return this.jsonSchema.encrypted || [];
    }
    /**
     * @overrides itself on the first call
     */

  }, {
    key: "hash",
    get: function get() {
      return Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* overwriteGetterForCaching */ "o"])(this, 'hash', Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* hash */ "j"])(this.normalized));
    }
  }]);

  return RxSchema;
}();
function getIndexes(jsonSchema) {
  return (jsonSchema.indexes || []).map(function (index) {
    return Array.isArray(index) ? index : [index];
  });
}
/**
 * returns the primary path of a jsonschema
 * @return primaryPath which is _id if none defined
 */

function getPrimary(jsonSchema) {
  var ret = Object.keys(jsonSchema.properties).filter(function (key) {
    return jsonSchema.properties[key].primary;
  }).shift();
  if (!ret) return '_id';else return ret;
}
/**
 * array with previous version-numbers
 */

function getPreviousVersions(schema) {
  var version = schema.version ? schema.version : 0;
  var c = 0;
  return new Array(version).fill(0).map(function () {
    return c++;
  });
}
/**
 * returns the final-fields of the schema
 * @return field-names of the final-fields
 */

function getFinalFields(jsonSchema) {
  var ret = Object.keys(jsonSchema.properties).filter(function (key) {
    return jsonSchema.properties[key]["final"];
  }); // primary is also final

  ret.push(getPrimary(jsonSchema));
  return ret;
}
/**
 * orders the schemas attributes by alphabetical order
 * @return jsonSchema - ordered
 */

function normalize(jsonSchema) {
  var normalizedSchema = Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* sortObject */ "x"])(Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* clone */ "d"])(jsonSchema));

  if (jsonSchema.indexes) {
    normalizedSchema.indexes = Array.from(jsonSchema.indexes); // indexes should remain unsorted
  }

  return normalizedSchema;
}
/**
 * fills the schema-json with default-settings
 * @return cloned schemaObj
 */

var fillWithDefaultSettings = function fillWithDefaultSettings(schemaObj) {
  schemaObj = Object(_util__WEBPACK_IMPORTED_MODULE_3__[/* clone */ "d"])(schemaObj); // additionalProperties is always false

  schemaObj.additionalProperties = false; // fill with key-compression-state ()

  if (!schemaObj.hasOwnProperty('keyCompression')) schemaObj.keyCompression = false; // indexes must be array

  schemaObj.indexes = schemaObj.indexes || []; // required must be array

  schemaObj.required = schemaObj.required || []; // encrypted must be array

  schemaObj.encrypted = schemaObj.encrypted || []; // add _rev

  schemaObj.properties._rev = {
    type: 'string',
    minLength: 1
  }; // add attachments

  schemaObj.properties._attachments = {
    type: 'object'
  }; // version is 0 by default

  schemaObj.version = schemaObj.version || 0;
  return schemaObj;
};
function createRxSchema(jsonSchema) {
  var runPreCreateHooks = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

  if (runPreCreateHooks) {
    Object(_hooks__WEBPACK_IMPORTED_MODULE_5__[/* runPluginHooks */ "d"])('preCreateRxSchema', jsonSchema);
  }

  var schema = new RxSchema(fillWithDefaultSettings(jsonSchema));
  Object(_hooks__WEBPACK_IMPORTED_MODULE_5__[/* runPluginHooks */ "d"])('createRxSchema', schema);
  return schema;
}
function isInstanceOf(obj) {
  return obj instanceof RxSchema;
}
//# sourceMappingURL=rx-schema.js.map

/***/ }),

/***/ "c9cd":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RxChangeEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return changeEventfromPouchChange; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return createInsertEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return createUpdateEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return createDeleteEvent; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return isInstanceOf; });
/**
 * RxChangeEvents a emitted when something in the database changes
 * they can be grabbed by the observables of database, collection and document
 */
var RxChangeEvent = /*#__PURE__*/function () {
  function RxChangeEvent(operation, documentId, documentData, databaseToken, collectionName, isLocal, startTime, endTime, previousData, rxDocument) {
    this.operation = operation;
    this.documentId = documentId;
    this.documentData = documentData;
    this.databaseToken = databaseToken;
    this.collectionName = collectionName;
    this.isLocal = isLocal;
    this.startTime = startTime;
    this.endTime = endTime;
    this.previousData = previousData;
    this.rxDocument = rxDocument;
  }

  var _proto = RxChangeEvent.prototype;

  _proto.isIntern = function isIntern() {
    if (this.collectionName && this.collectionName.charAt(0) === '_') {
      return true;
    } else {
      return false;
    }
  };

  _proto.toJSON = function toJSON() {
    var ret = {
      operation: this.operation,
      documentId: this.documentId,
      documentData: this.documentData,
      previousData: this.previousData ? this.previousData : undefined,
      databaseToken: this.databaseToken,
      collectionName: this.collectionName,
      isLocal: this.isLocal,
      startTime: this.startTime,
      endTime: this.endTime
    };
    return ret;
  };

  _proto.toEventReduceChangeEvent = function toEventReduceChangeEvent() {
    switch (this.operation) {
      case 'INSERT':
        return {
          operation: this.operation,
          id: this.documentId,
          doc: this.documentData,
          previous: null
        };

      case 'UPDATE':
        return {
          operation: this.operation,
          id: this.documentId,
          doc: this.documentData,
          previous: this.previousData ? this.previousData : 'UNKNOWN'
        };

      case 'DELETE':
        return {
          operation: this.operation,
          id: this.documentId,
          doc: null,
          previous: this.previousData
        };
    }
  };

  return RxChangeEvent;
}();
function changeEventfromPouchChange(changeDoc, collection, startTime, // time when the event was streamed out of pouchdb
endTime) {
  var operation = changeDoc._rev.startsWith('1-') ? 'INSERT' : 'UPDATE';

  if (changeDoc._deleted) {
    operation = 'DELETE';
  } // decompress / primarySwap


  var doc = collection._handleFromPouch(changeDoc);

  var documentId = doc[collection.schema.primaryPath];
  var cE = new RxChangeEvent(operation, documentId, doc, collection.database.token, collection.name, false, startTime, endTime);
  return cE;
}
function createInsertEvent(collection, docData, startTime, endTime, doc) {
  var ret = new RxChangeEvent('INSERT', docData[collection.schema.primaryPath], docData, collection.database.token, collection.name, false, startTime, endTime, null, doc);
  return ret;
}
function createUpdateEvent(collection, docData, previous, startTime, endTime, rxDocument) {
  return new RxChangeEvent('UPDATE', docData[collection.schema.primaryPath], docData, collection.database.token, collection.name, false, startTime, endTime, previous, rxDocument);
}
function createDeleteEvent(collection, docData, previous, startTime, endTime, rxDocument) {
  return new RxChangeEvent('DELETE', docData[collection.schema.primaryPath], docData, collection.database.token, collection.name, false, startTime, endTime, previous, rxDocument);
}
function isInstanceOf(obj) {
  return obj instanceof RxChangeEvent;
}
//# sourceMappingURL=rx-change-event.js.map

/***/ }),

/***/ "d385":
/***/ (function(module, exports) {


//# sourceMappingURL=crypto-js.d.js.map

/***/ })

}]);
//# sourceMappingURL=vue-rxdb-hasura.umd.vue-rxdb-hasura.umd~78efb4f7.js.map